// C Source File
// Created 21/02/2002; 18:19:37

//options de compilation:
//  pour tigcc:  -Os -Wall -W -Wwrite-strings
//  pour A68k:  -g -t

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File
#define USE_V200

#define USE_KERNEL

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

//only one version to compile at time !
#define VERSION_FR
//#define VERSION_ENG

#include <tigcclib.h>         // Include All Header Files

#include "key.h"							// touches pour rowread
#ifdef USE_KERNEL
  #include "zip.h"							// pour utiliser ziplib
#else
  #include "zip2.h"							// fonction de compression de Franois Lieber
#endif
#include "fastgraph.h"				// pour l'affichage de texte, de ligne : optimis par TICT
#include "textes.h"						// tous les textes de prog



//donne la longeur d'un caractre en foncton de sa taille
#define LONGCHAR(taille1,taille2,caractere)		( (taille1 | taille2) ? val_long[taille1] : charwidth[caractere] )


//donne la taille au-dessus de la "ligne de texte"
#define HAUT_EXP(frt) val_haut[(frt.taille1<<1)+frt.taille2]\
											+(frt.haut_exp1 | frt.haut_exp2)*(val_haut[3-((frt.haut_exp1)<<1)-(frt.haut_exp2)]>>1)\
											+((frt.conjug | frt.vecteur)*3)

//donne la taille en-dessous de la "ligne de texte"
#define HAUT_INDICE(frt)	(frt.haut_max_indice1 | frt.haut_max_indice2)*\
													(  val_haut[3-((frt.haut_max_indice1)<<1)-(frt.haut_max_indice2)]  -  (val_haut[3-((frt.haut_exp1)<<1)-(frt.haut_exp2)]>>1)  )\
													+((frt.souligne | frt.pointille)<<1)


#define AUTO_WORDWARP 0

#define VIT_MENU_DEF 30
#define VIT_MENU_MAX 50
#define VIT_MENU_MIN 10

#define VIT_DEFIL_DEF 10
#define VIT_DEFIL_MAX 50
#define VIT_DEFIL_MIN 0

#define HIST_NB_MAX_DEF 10
#define HIST_NB_MAX_MIN 1

#define AUTO_DEL_DBL_DEF    1;
#define AUTO_QUIT_DEF       1;
#define CONFIRM_DEL_DEF     1;
#define CONFIRM_DEL_DBL_DEF 1;

#define disp(str, format...)		 {printf(str , ##format);	wait(vit_menu); pause();}
//#define disp(str, format...)		 {printf(str , ##format);	wait(vit_menu);}
//#define disp(str, format...)		 {printf(str , ##format);}
//#define disp(str, format...)		 ;

//=======================================================================================================================
//================================================== Variable globales ==================================================
//=======================================================================================================================

#define VERSION 107

const unsigned char * message_fin = "Hib-Text 1.0b7 by hibou@bonbon.net";

/*
		Format possible d'un caractre ou d'un ddut de ligne:
souligne: 1 ou 0
pointille: 1 ou 0
vecteur: 1 ou 0
conjug: si vecteur=0 : 1 ou 0: conjugu
				si vecteur=1 : 1 : fin du vecteur: flche du vecteur
											 0 : milieu du vecteur: juste un trait
barre: 1 ou 0
taille1 - taille2 : 0-0 : petite police
										0-1 : moyenne police
										1-0 : grande police
										
la hauteur de l'exposant et d'un indice dpend de la taille du caractre prcdent
haut_exp1 & haut_exp2 : ~taille1 & ~taille2 de la police avant l'exposant ou l'indice      <= complment !!
haut_max_indice1 - haut_max_indice2 : ~taille1 & ~taille2 de la plus grande police de tout l'indice     <= complment  !!

  => si haut_exp1=0 & haut_exp2=0 : pas d'exposant ni d'indice
  => si haut_max_indice1=0 & haut_max_indice2=0 : exposant
  => sinon indice
*/

typedef struct {
		unsigned short souligne:1, pointille:1,
									 conjug:1, vecteur:1,
									 barre:1,
									 inverse:1,
									 taille1:1, taille2:1,
									 haut_exp1:1, haut_exp2:1,
									 haut_max_indice1:1, haut_max_indice2:1;
} FORMAT;

typedef struct {
		unsigned char  * nom_fold;  //pointeur ! En fait SymPtr->name
		unsigned char  * nom_var;
		unsigned char  typ;  //0=rien 1=normal, 2=zipp
		unsigned char  * texte;
		unsigned short longueur;
		
		unsigned short taille_var;
		unsigned short * ptr_txt;  //numro des cases de texte de dbut de ligne
		FORMAT         * format_ligne;
		unsigned char  * haut_ligne;  // taille en hauteur que prend une ligne
		unsigned char  * pos_x_ligne;  //marge et alignement
		
		unsigned short * ptr_liens;
		short          nb_liens;
		
		unsigned short * marque_page;
		short          nb_marque;
		
		void          * tampon_haut;  //adresse des tampons graphiques
		void          * tampon_bas;
		unsigned char taille_tampon;
} FILE_TXT;

FILE_TXT * file_txt;
//tab_var : tableau de 8+1 : nom fold
//                     8+1 : nom var
//                     1 : marque-page
/*
typedef struct {
		unsigned char nb;
		unsigned char nb_max;
		unsigned char * tab_var;
} HIST;*/

typedef struct {
		unsigned char nb;
		unsigned char * tab_var;
} TAB_TXT;

TAB_TXT * favoris;
TAB_TXT * historique;

unsigned char max_hist;
/*
typedef struct {
		unsigned char nb;
		unsigned char * tab_var;
} FAV;*/

unsigned char vit_menu=100;
unsigned char vit_defil=0;
unsigned char auto_del_dbl=1;
unsigned char auto_quit=1;
unsigned char confirm_del=1;
unsigned char confirm_del_dbl=1;

void * vscreen=NULL;

#define HAUT_NO_IMG 21
unsigned char no_pic[] ={ 0, 20, 0, 16, 0x1F, 0xFF,
																				0x10, 0x01,
																				0x10, 0xF9,
																				0x11, 0xFD,
																				0x13, 0x1D,
																				0x16, 0x19,
																				0x16, 0x19,
																				0x16, 0x31,
																				0x10, 0x61,
																				0x10, 0x61,
																				0x10, 0xC1,
																				0x11, 0x81,
																				0x11, 0x81,
																				0x11, 0x81,
																				0x10, 0x01,
																				0x10, 0xC1,
																				0x11, 0xE1,
																				0x11, 0xC1,
																				0x10, 0x01,
																				0x1F, 0xFF};

unsigned char lien_gauche[] ={0x7F,
															0xF0,
															0xE0,
															0xC0,
															0xC0,
															0xC0,
															0xE0,
															0xF0,
															0x7F};

unsigned char lien_droite[] ={0xFE,
															0x0F,
															0x07,
															0x03,
															0x03,
															0x03,
															0x07,
															0x0F,
															0xFE};

//=======================================================================================================================
//============================== Fonction encore plus rapide que _rowread (Merci Thibaut!) ==============================
//=======================================================================================================================

extern unsigned short f_rowread(short masque);
asm("
f_rowread:
/* Source : bibliothque Azur par Thibaut Barthlemy */
 move.w  4(%a7),0x600018
 lsr.w   #8,%d0
 lsr.w   #4,%d0
 move.l  (%a7)+,%a0
 move.b  0x60001B,%d0
 not.b   %d0
 jmp     (%a0)
");

//=======================================================================================================================
//==================================================== Petite pause =====================================================
//=======================================================================================================================

void wait(const unsigned char temps) {
		unsigned short i,j;
		
		for (i=0;i<((unsigned short)temps);i++)
				for (j=0;j<65000;j++)
						;
}

//=======================================================================================================================
//======================================================== Pause ========================================================
//=======================================================================================================================

void pause(void) {
		while (!(K_ENTER || K_ESC))
				;
		wait(vit_menu);
}

//=======================================================================================================================
//======================================================== Affichage d'un message ========================================================
//=======================================================================================================================

void message(const unsigned char * texte) {

		unsigned char y=(LCD_HEIGHT>>1)-8;
		
		wait(vit_menu);
		memset(LCD_MEM+y*30,0,16*30);
		FastestDrawHLine(LCD_MEM,y);
		FastestDrawHLine(LCD_MEM,y+2);
		FastestDrawHLine(LCD_MEM,y+14);
		FastestDrawHLine(LCD_MEM,y+16);
		FastStr(((LCD_WIDTH-strlen(texte)*6)>>1),y+5,texte,LCD_MEM,POLICE_2);
}

//=======================================================================================================================
//======================================= Change la taille d'une variable alloue =======================================
//=======================================================================================================================

unsigned char augment_taille(void * * data, unsigned short taille, unsigned short augment, unsigned short size_typ) {
		unsigned char * data2;
		
		if ((data2=malloc((taille+augment)*size_typ))==NULL)
				return 0;
		memcpy(data2,*data,taille*size_typ);
		memset(data2+taille*size_typ,0,augment*size_typ);
		free(*data);
		*data=data2;
		return 1;
}

//=======================================================================================================================
//==================================== Routines de dfilement d'cran (merci TICT!) =====================================
//=======================================================================================================================

void defile_haut(void* ecran, short pos_y) {
		register short  * dest    = ecran;
		register short  * src     = dest+15;
		register short  tmplines  = LCD_HEIGHT-2;

/*		wait(vit_defil);  //pour ralentir
pb ca ralenti de trop, meme tant  0 !*/

//dfilement dans l'cran
		asm volatile (
				"0:
				move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
				move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
				move.l (%0)+,(%1)+;move.w (%0)+,(%1)+
				dbra %2,0b"
				: "=a" (src), "=a" (dest), "=d" (tmplines)
				: "0"  (src),  "1" (dest), "2"  (tmplines));

//copie de la ligne de tampon_bas dans la dernire de LCD_MEM
		src=file_txt->tampon_bas+30*pos_y;
		asm volatile (
				"move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
				move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
				move.l (%0)+,(%1)+;move.w (%0)+,(%1)+"
				: "=a" (src), "=a" (dest)
				: "0"  (src),  "1" (dest));
}


void defile_bas(void * ecran, short pos_y) {
		register short * dest   = ecran;
		register short * src;
		register short tmplines = LCD_HEIGHT-2;
		
		dest+=15*LCD_HEIGHT;
		src=dest-15;

//dfilement dans l'cran
		asm volatile (
				"0:
				move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
				move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
				move.l -(%0),-(%1);move.w -(%0),-(%1)
				dbra %2,0b"
				: "=a" (src), "=a" (dest), "=d" (tmplines)
				: "0"  (src), "1"  (dest), "2"  (tmplines));

//copie de la ligne de tampon_haut dans la premire ligne LCD_MEM
		src=file_txt->tampon_haut+30*(pos_y+1);
		asm volatile (
				"move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
				move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
				move.l -(%0),-(%1);move.w -(%0),-(%1)"
				: "=a" (src), "=a" (dest)
				: "0"  (src), "1"  (dest));

}
//=======================================================================================================================
//========================================= Etude d'une expression pretty-print =========================================
//=======================================================================================================================

unsigned char etude_pprint(unsigned short *pos_txt) {

		short          largeur;
		short          bas;
		short          haut;
//		HANDLE         h;
		unsigned char  * expr;
		unsigned char  * texte = file_txt->texte;
		unsigned short j       = (*pos_txt+=2);

//disp("etu")
		while (texte[j]!=13 && texte[j]!=0)  //recherche de la taille de l'expression
				j++;
//disp("j=%d,pos_txt=%d,txt=%c%c%c%c%c%c\n",j,*pos_txt,texte[*pos_txt],texte[*pos_txt+1],texte[*pos_txt+2],texte[*pos_txt+3],texte[*pos_txt+4],texte[*pos_txt+5])
		if ((expr=malloc((j-(*pos_txt)+5)*sizeof(unsigned char)))==NULL) {
				message(TXT_MQ_MEM("10"));  //on a pas russi...
				pause();
				return 0;
		}
		j=0;
		while (texte[*pos_txt]!=13 && texte[*pos_txt]!=0)  //copie de l'expression
				expr[j++]=texte[(*pos_txt)++];

		expr[j]=0;
		*pos_txt+=2;
//disp("j=%d,pos_txt=%d,expr=%s\n",j,*pos_txt,expr)
		TRY
				push_END_TAG();
				push_parse_text(expr);
//				NG_rationalESI (top_estack);  //"calcul" de l'expression
				Parms2D(Parse2DExpr(top_estack,FALSE), &largeur, &bas, &haut);  //obtention de ses dimensions
//		disp("h=%d,b=%d,l=%d,expr=%s,haut=%d",haut,bas,largeur,expr,haut+bas+1);
		ONERR
				bas=0;
				haut=5;  //on a pas russi... => dimension du message d'erreur
		ENDTRY
		free(expr);
//		disp("h=%d",haut+bas+3);
		return haut+bas+3;
}

//=======================================================================================================================
//================================================== Etude d'une image ==================================================
//=======================================================================================================================

unsigned char etude_image(unsigned short *pos_txt) {

		SYM_ENTRY     * SymPtr;
		unsigned char * data;                     //  pointeur vers les donnes de l'image
		unsigned char * data2;                    // pointeur pour la dcompression de l'image
		short         longueur;                   //longueur de la variable
		short         j = 0;
		unsigned char * texte = file_txt->texte;
		unsigned char name_var[20];               //char pour symfind
		HANDLE h;
		
		name_var[0] = 0;
		*pos_txt+=2;

		while (texte[*pos_txt+j]!=13 && texte[*pos_txt+j]!=0) {  //copie du nom de l'image
				if (j<17)  //longueur de nom impossible 8+1+8
						name_var[j+1]=texte[*pos_txt+j];
				j++;
		}
		
		*pos_txt+=j+2; //retourne la nouvelle valeur de pos_txt
		
		if (j>=17)
				return HAUT_NO_IMG;	//taille de l'image "image incorrecte"

		name_var[(++j)]=0;  //caractre de fin de char

		if ((SymPtr = DerefSym(SymFind(name_var+j)))==NULL)  //recherche de son entre dans la VAT
				return HAUT_NO_IMG;	//taille de l'image "image incorrecte"

		data=(unsigned char *)HeapDeref(SymPtr->handle);
		longueur=*(unsigned short *)data;

		if (data[longueur+1]==PIC_TAG) {
				return data[3]+1;  //on retourne la taille de l'image
		} else if (data[longueur+1]==OTH_TAG) {  //peut-tre un zip
#ifdef USE_KERNEL
				if (strcmp(&(data[longueur-3]),"ZIP")==0 && data[2]==0x0B) {  //image compresse
						longueur=((unsigned short *)data)[6];  //longueur dzipp
						if ((data2=HeapDeref(h=HeapAlloc((longueur+5)*sizeof(unsigned char))))==NULL) {
								message(TXT_MQ_MEM("8"));
								pause();
								return 0;
						}
						extract(data+4,data2);  //on dcompresse
						j=data2[1]+1;  //on mmorise la hauteur de l'image avant de librer la mmoire
						HeapFree(h);
						return (unsigned char)j;
				}
#else
		h=0;
		data2=NULL;
		return HAUT_NO_IMG;
#endif
		}
		return HAUT_NO_IMG;

}


//=======================================================================================================================
//============================================= Etude d'une ligne de texte ==============================================
//=======================================================================================================================

unsigned short etude_ligne(unsigned short no_ptr, unsigned char *aligne, unsigned char *marge, unsigned char *wordwarp, short *taille_var_lien) {

//variables du texte
		unsigned char  * texte        = file_txt->texte;
		unsigned short * ptr_txt      = file_txt->ptr_txt;
		FORMAT         * format_ligne = file_txt->format_ligne;
		unsigned char  * pos_x_ligne  = file_txt->pos_x_ligne;
		unsigned char  * haut_ligne   = file_txt->haut_ligne;
		unsigned short * ptr_liens    = file_txt->ptr_liens;

		const unsigned char val_long[] = {6,8};			//longueur d'un caractre
		const unsigned char val_haut[] = {6,8,10};  //sa hauteur

//_old: pour retenir les valeurs pour faire du word warp

		unsigned short pos_txt     = ptr_txt[no_ptr];  //position dans le texte
		unsigned short old_pos_txt = 0;

		unsigned char  l = 0;  //variables temporaires
		unsigned short j;
		
		unsigned char caract1 = 0;  //caractres en tude
		unsigned char caract2 = 0;
		unsigned char caract3 = 0;

		unsigned char long_txt     = 0;  //longueur totale du texte
		unsigned char old_long_txt = 0;
	
		FORMAT format_courant;
		FORMAT old_format;
		
		FORMAT * ptr_format_courant = &format_courant;
		FORMAT * ptr_old_format     = &old_format;

		unsigned char exp_max;             //hauteur d'un exposant
		unsigned char indice_max;          // taille max d'uun indice
		unsigned char old_exp_max    = 0;
		unsigned char old_indice_max = 0;
		
//initialisation du format
		memcpy(ptr_format_courant,&(format_ligne[no_ptr]),sizeof(FORMAT));  //chargement du format

//pour les formats de lignes entires:
format_ligne:  //au cas ou il y a plusieurs formatages qui se suivent
		if (texte[pos_txt-2]==13 || pos_txt==1) {//si on est en dbut de ligne de texte TI-OS
				if (texte[pos_txt]=='&') {
						switch (caract2=texte[pos_txt+1]) {
								case 'P':  //une image
										if ((haut_ligne[no_ptr]=etude_image(&pos_txt))==0)
												return 0;
										goto fin;
								case 'E':  //un pretty print
										if ((haut_ligne[no_ptr]=etude_pprint(&pos_txt))==0)
												return 0;
										goto fin;
								case '-':  //ligne sparatrice
										haut_ligne[no_ptr]=3;
										if (texte[(pos_txt+=2)]==13)
												pos_txt+=2;
										goto fin;
								case '=':  //double ligne sparatrice
										haut_ligne[no_ptr]=5;
										if (texte[(pos_txt+=2)]==13)
												pos_txt+=2;
										goto fin;
								case 'L':		//alignement  gauche
										*aligne=0;
										pos_txt+=2;
										goto format_ligne;
								case 'C':		//centr
										*aligne=1;
										pos_txt+=2;
										goto format_ligne;
								case 'R':		// alignement  droite
										*aligne=2;
										pos_txt+=2;
										goto format_ligne;
								case '\\':  // marge de 0
										*marge=0;
										pos_txt+=2;
										goto format_ligne;
								case ',':  // marge de 10
										*marge=10;
										pos_txt+=2;
										goto format_ligne;
								case ';':  // marge de 20
										*marge=20;
										pos_txt+=2;
										goto format_ligne;
								case '.':  // marge de 30
										*marge=30;
										pos_txt+=2;
										goto format_ligne;
								case '&':  //on veut afficher un &
										pos_txt++;
										goto deb_etude;
								case 'M':  //marge personalise
										caract1=texte[pos_txt+2];
										caract2=texte[pos_txt+3];
										caract3=texte[pos_txt+4];
										if (caract1>='0' && caract1<='9' && caract2>='0' && caract2<='9' && caract3>='0' && caract3<='9') {
												*marge=(caract3-'0')+10*(caract2-'0')+100*(caract1-'0');  //calcul de la taille de la marge
												if (*marge>=LCD_WIDTH-10)  //interdiction d'une marge trop grande
														*marge=LCD_WIDTH-10;
												pos_txt+=5;
												goto format_ligne;
										}
						}
				}
		}

//recherche si y'a tout de suite un changement de format: influence sur la hauteur max de la ligne
format:  //rebouclage : il peut y avoir plusieurs changements de format
		if (texte[pos_txt]=='#') {
				switch (caract2=texte[pos_txt+1]) {
						case '1':  //si on change tout de suite de taille de police
						case '2':
						case '3':
								format_courant.taille1=(((caract2-='1')&0x02)>>1);
								format_courant.taille2=(caract2&0x01);  //changement de police
								pos_txt+=2;
								goto format;
						case 'W': //word warp
								*wordwarp=1-*wordwarp;
								pos_txt+=2;
								goto format;
						case 'U':  //soulign
								format_courant.souligne=~format_courant.souligne;
								format_courant.pointille=0;
								pos_txt+=2;
								goto format;
						case 'N':  //soulign pointill
								format_courant.pointille=~format_courant.pointille;
								format_courant.souligne=0;
								pos_txt+=2;
								goto format;
						case 'J':  //conjugu
								format_courant.conjug=~format_courant.conjug;
								format_courant.vecteur=0;
								pos_txt+=2;
								goto format;
						case 'V':  //vecteur
								format_courant.vecteur=~format_courant.vecteur;
								format_courant.conjug=0;
								pos_txt+=2;
								goto format;
						case 'S':  //invers
								format_courant.barre=~format_courant.barre;
								pos_txt+=2;
								goto format;
						case 'I':  //invers
								format_courant.inverse=~format_courant.inverse;
								pos_txt+=2;
								goto format;
						case 'E':  //exposant
								if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
										if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
												format_courant.haut_max_indice1=0;  //on passe  l'exposant
												format_courant.haut_max_indice2=0;
												if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
														format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
														format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
														pos_txt+=2;
												}
										} else {  //c'est un exposant
												format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
												format_courant.taille2=~format_courant.haut_exp2;
												format_courant.haut_exp1=0;
												format_courant.haut_exp2=0;
										}
								} else { //y'avais du texte normal : on passe  l'exposant
										format_courant.haut_exp1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'exposant
										format_courant.haut_exp2=~format_courant.taille2;
										pos_txt+=2;
										if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
												format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
												format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
												pos_txt+=2;
										} else {  //on baisse de police automatiquement
												format_courant.taille2=format_courant.taille1;
												format_courant.taille1=0;
										}
								}
								goto format;
						case 'D':  //indice
								if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
										if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
												format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
												format_courant.taille2=~format_courant.haut_exp2;
												format_courant.haut_max_indice1=0;
												format_courant.haut_max_indice2=0;
												format_courant.haut_exp1=0;
												format_courant.haut_exp2=0;
										} else {  //c'est un exposant
												format_courant.haut_max_indice1=~format_courant.taille1;
												format_courant.haut_max_indice2=~format_courant.taille2;
										}
								} else {//on tait en normal
										format_courant.haut_exp1=~format_courant.taille1;
										format_courant.haut_exp2=~format_courant.taille2;
										pos_txt+=2;
										if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
												format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
												format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
												pos_txt+=2;
										} else {  //on baisse de police automatiquement
												format_courant.taille2=format_courant.taille1;
												format_courant.taille1=0;
										}
										format_courant.haut_max_indice1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'indice
										format_courant.haut_max_indice2=~format_courant.taille2;
								}
								goto format;
				}
		}

deb_etude:
		memcpy(&(format_ligne[no_ptr]),ptr_format_courant,sizeof(FORMAT));  //on modifie le format du dbut de la ligne

		exp_max=HAUT_EXP(format_courant);
		indice_max=HAUT_INDICE(format_courant);

		while (texte[pos_txt]!=13 && texte[pos_txt]!=0) {  //retour  la ligne ou fin du texte
				caract1=texte[pos_txt++];
				if (caract1=='#') {  //possible formatage...
						caract2=texte[pos_txt++];
						switch (caract2) {
								case '#':  //afficher un dise seulement
										if (((l=long_txt+LONGCHAR(format_courant.taille1,format_courant.taille2,caract2)))<=LCD_WIDTH-(*marge)) { //si on ne dpasse pas l'cran
												long_txt=l;  //on comptabilise sa longueur
										} else {  //sinon on recule et on quitte
												pos_txt-=2;
												goto suite;
										}
										break;
								case '1':
								case '2':
								case '3':
										format_courant.taille1=(((caract2-='1')&0x02)>>1);
										format_courant.taille2=(caract2&0x01);  //changement de police
										if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //si on est en indice
												if (caract2>3-((format_courant.haut_max_indice1)<<1)-format_courant.haut_max_indice2) {  //y'a peut etre un changement de taile max d'indice
														format_courant.haut_max_indice1=~format_courant.taille1;
														format_courant.haut_max_indice2=~format_courant.taille2;
												}
										}
										break;
								case 'W':
										*wordwarp=1-*wordwarp;
										break;
								case 'U':
										format_courant.souligne=~format_courant.souligne;
										format_courant.pointille=0;
										break;
								case 'N':
										format_courant.pointille=~format_courant.pointille;
										format_courant.souligne=0;
										break;
								case 'J':
										format_courant.conjug=~format_courant.conjug;
										format_courant.vecteur=0;
										break;
								case 'V':
										format_courant.vecteur=~format_courant.vecteur;
										format_courant.conjug=0;
										break;
								case 'S':  //barr
										format_courant.barre=~format_courant.barre;
										break;
								case 'I':  //couleur inverse
										format_courant.inverse=~format_courant.inverse;
										break;
								case 'C':  //caractre spcial
										caract1=texte[pos_txt];
										caract2=texte[pos_txt+1];
										caract3=texte[pos_txt+2];
										if (caract1>='0' && caract1<='9' && caract2>='0' && caract2<='9' && caract3>='0' && caract3<='9') {  //y'a trois chiffres qui se suivent
												if ((j=(caract3-'0')+10*(caract2-'0')+100*(caract1-'0'))<256) {  //y'a que 255 caractres !
														if ((l=long_txt+(LONGCHAR(format_courant.taille1,format_courant.taille2,j)))<=LCD_WIDTH-(*marge)) {  //on n'est pas arriv au bout de l'cran
																long_txt=l;
																pos_txt+=3;
																break;
														}
														pos_txt-=2;  //on recule et on quitte
														goto suite;
												}
										}
										pos_txt--;	//mauvaise saisie : affichage normal
										goto affnormal;
								case 'E':  //exposant
										if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
												if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
														format_courant.haut_max_indice1=0;  //on passe  l'exposant
														format_courant.haut_max_indice2=0;
														if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
																format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
																format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
																pos_txt+=2;
														}
												} else {  //c'est un exposant
														format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
														format_courant.taille2=~format_courant.haut_exp2;
														format_courant.haut_exp1=0;
														format_courant.haut_exp2=0;
												}
										} else { //y'avais du texte normal : on passe  l'exposant
												format_courant.haut_exp1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'exposant
												format_courant.haut_exp2=~format_courant.taille2;
												if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
														format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
														format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
														pos_txt+=2;
												} else {  //on baisse de police automatiquement
														format_courant.taille2=format_courant.taille1;
														format_courant.taille1=0;
												}
										}
										break;
								case 'D':  //indice
										if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
												if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
														format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
														format_courant.taille2=~format_courant.haut_exp2;
														format_courant.haut_max_indice1=0;
														format_courant.haut_max_indice2=0;
														format_courant.haut_exp1=0;
														format_courant.haut_exp2=0;
												} else {  //c'est un exposant
														format_courant.haut_max_indice1=~format_courant.taille1;
														format_courant.haut_max_indice2=~format_courant.taille2;
												}
										} else {//on tait en normal
												format_courant.haut_exp1=~format_courant.taille1;
												format_courant.haut_exp2=~format_courant.taille2;
												if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
														format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
														format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
														pos_txt+=2;
												} else {  //on baisse de police automatiquement
														format_courant.taille2=format_courant.taille1;
														format_courant.taille1=0;
												}
												format_courant.haut_max_indice1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'indice
												format_courant.haut_max_indice2=~format_courant.taille2;
										}
										break;
								case 'L':  //lien hypertexte
										if ((l=long_txt+14)<=LCD_WIDTH-(*marge)) {  //si il y a la place de mettre un lien
												long_txt=l;
												ptr_liens[file_txt->nb_liens++]=pos_txt;  //mmorisation de la position du lien
												if (file_txt->nb_liens==(*taille_var_lien)) {  //changement de taille de var
														if ((augment_taille((void * *)(&ptr_liens),*taille_var_lien,10,sizeof(unsigned short)))==0) {
																message(TXT_MQ_MEM("7"));
																pause();
																return 0;
														}
														*taille_var_lien+=10;
												}
												while ( (texte[pos_txt]!='#' || texte[pos_txt+1]!='L') && texte[pos_txt]!=13 && texte[pos_txt]!=0)  //on saute tout le lien
														pos_txt++;
												if (texte[pos_txt++]!=0)
														pos_txt++;
												if (exp_max<10)
														exp_max=10;
										} else {
												pos_txt-=2;
												goto suite;
										}
										break;
								default:  //pas de caractre  vocation de mise en page
										pos_txt--;
										goto affnormal;  //affichage normal
						}//fin du switch
				} else {  //pas de caractre #: affichage normal
affnormal:
						if (caract1==' ' && *wordwarp==1) {  //possibilit d'arreter l l'affichage pour le wordwarp
								old_pos_txt=pos_txt;   //sauvegarde des valeurs
								old_long_txt=long_txt;
								memcpy(ptr_old_format,ptr_format_courant,sizeof(FORMAT));
								old_exp_max=exp_max;
								old_indice_max=indice_max;
						}
						if ((l=long_txt+(LONGCHAR(format_courant.taille1,format_courant.taille2,caract1)))<=LCD_WIDTH-(*marge)) {  //on n'est pas arriv au bout de l'cran
								long_txt=l;
						} else {  //sinon on recule et on quitte
								pos_txt--;
								break;
						}
				}
				if ((l=HAUT_EXP(format_courant))>exp_max)  //recherche des changements de taille max
						exp_max=l;
				if ((l=HAUT_INDICE(format_courant))>indice_max)
						indice_max=l;
		}

suite:
		if (texte[pos_txt]==13)  // si on s'arrte exactement sur un retour  la ligne
				pos_txt+=2;
		else if (texte[pos_txt]==' ') //on fini sur un espace
				pos_txt++;
		else if (*wordwarp==1 && texte[pos_txt]!=0 && old_pos_txt!=0) {  //on fait du "word warp"
				pos_txt=old_pos_txt;  //on remet les anciennes valeurs
				long_txt=old_long_txt;
				memcpy(ptr_format_courant,ptr_old_format,sizeof(FORMAT));
				exp_max=old_exp_max;
				indice_max=old_indice_max;
		}

		pos_x_ligne[no_ptr]=( !(*aligne) ? *marge : (*aligne)*((LCD_WIDTH-long_txt+1)>>1));  //mmorisation de la position du texte
		
		haut_ligne[no_ptr]=indice_max+exp_max;  //mmorisation de sa hauteur
		
fin:   //pour les lignes sparatrices
		memcpy(&(format_ligne[no_ptr+1]),ptr_format_courant,sizeof(FORMAT));  //mmorisation pour du format pour la ligne suivante
		if (file_txt->taille_tampon<=haut_ligne[no_ptr])  //si le tampon n'est plus assez grand
				file_txt->taille_tampon=haut_ligne[no_ptr]+2;
		return pos_txt;
}

//=======================================================================================================================
//=============================================== Etude de tout le texte ================================================
//=======================================================================================================================

unsigned short etude_txt(void) {
	
		unsigned short no_ptr          = 0;
//		short          taille_marque   = 10;
		unsigned char  y;
		short          taille_var_lien = 10;
		
//variable du texte
		unsigned char  * texte        = file_txt->texte;
		unsigned short * ptr_txt      = file_txt->ptr_txt;
		FORMAT         * format_ligne = file_txt->format_ligne;
		unsigned char  * pos_x_ligne  = file_txt->pos_x_ligne;
		unsigned char  * haut_ligne   = file_txt->haut_ligne;
		unsigned short * marque_page;
		unsigned short no_marque      = 0;
//mmorisation des paramtres d'affichage du texte
		unsigned char aligne   = 0;
		unsigned char marge    = 0;
		unsigned char wordwarp = AUTO_WORDWARP;

//compte des marques pages
		while (texte[no_ptr]!=0)
				if (texte[no_ptr++]==13)
						if (texte[no_ptr]==12)
								file_txt->nb_marque++;

		if ((file_txt->marque_page=malloc((file_txt->nb_marque+1)*sizeof(unsigned short)))==NULL) {
				message(TXT_MQ_MEM("2"));
				pause();
				return 0;
		}
		memset(file_txt->marque_page,0,(file_txt->nb_marque+1)*sizeof(unsigned short));
		marque_page  = file_txt->marque_page;
		no_ptr=0;
		while (texte[ptr_txt[no_ptr]]!=0) {	//tant qu'on est pas arriv au bout du texte
				if ((ptr_txt[no_ptr+1]=etude_ligne(no_ptr,&aligne,&marge,&wordwarp,&taille_var_lien))==0)  //tude d'une ligne
						return 0;
				no_ptr++;
				if (texte[ptr_txt[no_ptr]-2]==13 && texte[ptr_txt[no_ptr]-1]==12)  //si retour  la ligne et page-break : marque page
						marque_page[no_marque++]=no_ptr;
				if (no_ptr+1==file_txt->taille_var) {  //si les variables ne sont plus assez grandes
						if ((augment_taille((void * *)(&ptr_txt),file_txt->taille_var,10,sizeof(unsigned short)))==0) {
								message(TXT_MQ_MEM("3"));
								pause();
								return 0;
						}
						file_txt->ptr_txt=ptr_txt;
						if ((augment_taille((void * *)(&format_ligne),file_txt->taille_var,10,sizeof(FORMAT)))==0) {
								message(TXT_MQ_MEM("4"));
								pause();
								return 0;
						}
						file_txt->format_ligne=format_ligne;
						if ((augment_taille((void * *)(&pos_x_ligne),file_txt->taille_var,10,sizeof(unsigned char)))==0) {
								message(TXT_MQ_MEM("5"));
								pause();
								return 0;
						}
						file_txt->pos_x_ligne=pos_x_ligne;
						if ((augment_taille((void * *)(&haut_ligne),file_txt->taille_var,10,sizeof(unsigned char)))==0) {
								message(TXT_MQ_MEM("6"));
								pause();
								return 0;
						}
						file_txt->haut_ligne=haut_ligne;
						file_txt->taille_var+=10;
				}						
		}

//recherche du dernier ptr_haut affichable
		y=0;
		while (y<LCD_HEIGHT && no_ptr>0)
				y+=haut_ligne[--no_ptr];

		return no_ptr+1;  //0 est rserv au problme de mmoire : d'o +1
}

//=======================================================================================================================
//======================================= Affichage d'une expression pretty-print =======================================
//=======================================================================================================================

void aff_pprint(unsigned short pos_txt, unsigned char y, void *ecran) {

		short          largeur;
		short          bas;
		short          haut;
		unsigned char  * expr;
		unsigned char  * texte = file_txt->texte;
		unsigned short j       =(pos_txt+=2);
//		HANDLE         h;
		
		while (texte[j]!=13 && texte[j]!=0)  //recherche de la taille de l'expression
				j++;
//disp("j=%d,pos_txt=%d",j,pos_txt)
		if ((expr=malloc((j-pos_txt+5)*sizeof(unsigned char)))==NULL) {
				FastStr(((LCD_WIDTH-LEN_TXT_MQ_MEM2*6)>>1),y,TXT_MQ_MEM2,ecran,POLICE_2);  //on a pas russi...
				return;
		}
		j=0;
		while (texte[pos_txt]!=13 && texte[pos_txt]!=0)  //copie de l'expression
				expr[j++]=texte[pos_txt++];
		expr[j]=0; //fin de la chane
//disp("j=%d,pos_txt=%d,expr=%s",j,pos_txt,expr)
		
		TRY
				push_END_TAG();
				push_parse_text(expr);
//				NG_rationalESI (top_estack);  //"calcul" de l'expression
				Parse2DExpr(top_estack,FALSE);  //mise en forme
				Parms2D(top_estack, &largeur, &bas, &haut);  //obtention de ses dimensions
				PortSet(vscreen,239,127);
				memset(vscreen+20*30,0,(bas+haut+3)*30);
//				FastestDrawHLine(vscreen,20);
				Print2DExpr(top_estack, DeskTop,((LCD_WIDTH-largeur)>>1),haut+20);  //affichage... (+20 car pas d'affichage dans toolbar!)
//				FastestDrawHLine(vscreen,20+haut+bas);
				memcpy(ecran+30*y,vscreen+20*30,(bas+haut+3)*30);    //...dans le bon ecran
				PortRestore();
//disp("haut=%d",haut+bas+3)
		ONERR
				FastStr(((LCD_WIDTH-LEN_TXT_ERR_EXPR*6)>>1),y,TXT_ERR_EXPR,ecran,POLICE_2);  //on a pas russi...
		ENDTRY
		
		free(expr);
}

//=======================================================================================================================
//================================================ Affichage d'une image ================================================
//=======================================================================================================================

void aff_image(unsigned short pos_txt, short pos_y, void *tampon) {
	
		SYM_ENTRY     * SymPtr;
		unsigned char * data;
		unsigned char * data2 = NULL;  //pour la dcompression de l'image
		HANDLE h=0;
		unsigned short longueur;
		short j=0;
		
		unsigned char pos_x;           //position d'affichage
		unsigned char name_var[20];    //variable pour symfind
		unsigned char *pic=no_pic;     //pic de l'image incorrecte par dfault
		
		unsigned char * texte=file_txt->texte;

		name_var[0] = 0;
		pos_txt+=2;

		while (texte[pos_txt+j]!=13 && j<17 && texte[pos_txt+j]!=0) {//copie du nom de l'image
				name_var[j+1]=texte[pos_txt+j];
				j++;
		}
		
		if (j>=17)
				goto aff_pic;  //on affiche no_pic
		
		name_var[(++j)]=0;
		
		if ((SymPtr = DerefSym(SymFind(name_var+j)))==NULL)  //recherche de l'image
				goto aff_pic;  //on affiche no_pic
		
		data=(unsigned char *)HeapDeref(SymPtr->handle);
		longueur=*(unsigned short *)data;
		
		if (data[longueur+1]==PIC_TAG) {
				pic=data+2;
		} else if (data[longueur+1]==OTH_TAG) {  //peut-etre un zip
#ifdef USE_KERNEL
				if (strcmp(&(data[longueur-3]),"ZIP")==0 && data[2]==0x0B) {  //image compress
						longueur=((unsigned short *)data)[6];  //longueur dzipp
						if ((data2=HeapDeref(h=HeapAlloc((longueur+5)*sizeof(unsigned char))))!=NULL) {
								//extract(data+4,data2);  //on dcompresse
								pic=data2;
						}
				}
#else
//no_pic
#endif
		}
		
aff_pic:

		pos_x=((LCD_WIDTH-pic[3])>>1);  //centrage de l'image
		PortSet(tampon,239, 127);
    BitmapPut(pos_x,pos_y,(void *)pic,&(SCR_RECT){{0,0,239,127}},A_NORMAL);  //on affiche
		PortRestore();

		if (data2!=NULL)  //si c'tait zipp
				HeapFree(h);  //on libre
}


//=======================================================================================================================
//=========================================== Affichage d'une ligne de texte ============================================
//=======================================================================================================================

void aff_ligne(unsigned short no_ptr, void *tampon, short pos_y) {

		unsigned short j=0;  //variable de boucle ou temporaire
		short i=0;
		
//variable du texte
		unsigned char  * texte        = file_txt->texte;
		unsigned short * ptr_txt      = file_txt->ptr_txt;
		FORMAT         * format_ligne = file_txt->format_ligne;
		unsigned char  * pos_x_ligne  = file_txt->pos_x_ligne;
		unsigned char  * haut_ligne   = file_txt->haut_ligne;
		unsigned short * ptr_liens    = file_txt->ptr_liens;
		
		const unsigned char val_font[]  = {6,8,10};		//valeurs de font
		const unsigned char val_font2[] = {18,10,0};	//valeurs de font2
		const unsigned char val_long[]  = {6,8};			//longueurs d'un caractre
		const unsigned char val_haut[]  = {6,8,10};  //hauteurs d'un caractre

		short  char_txt[130];          //tout les char que nous allons afficher : short pour les liens : caract = - no_liens
		FORMAT format_caract[130];  //format de chaque caractre
		FORMAT *ptr_format_caract;  //pointeur temporaire pour eviter des calculs superflus

		unsigned char exp_max;  //hauteur d'un exposant
		unsigned char no_lien;  //no du lien 

//variable pour affichage
		unsigned char x=0;              //position du texte
		unsigned char x2;
		unsigned char long_caract = 0;  //longueur totale du texte
		short         caract;           //caractre  afficher
		unsigned char police;           //police du caractre
		unsigned char pos_y_texte = 0;  //position de la ligne de texte

//variable pour tude
		unsigned char  caract1        = 0;  //caractres en tude
		unsigned char  caract2        = 0;
		unsigned char  caract3        = 0;
		unsigned short nb_caract      = 0;  //nombre de caractre  afficher
		unsigned short caract_pos_txt = 0;  //pour avoir la case du dernier caractre affich pour le format vecteur
		unsigned short pos_txt        = 0;  //position dans le texte

		FORMAT format_courant;
		FORMAT * ptr_format_courant;

//initialisation des variables
		pos_txt            = ptr_txt[no_ptr];
		ptr_format_courant = &format_courant;
		memcpy(ptr_format_courant,&(format_ligne[no_ptr]),sizeof(FORMAT));

		
//pour les formats de lignes entires:		
format_ligne:
		if (texte[pos_txt-2]==13 || pos_txt==1) {//si dbut de ligne de texte TI-OS
				if (texte[pos_txt]=='&') {
						switch (caract2=texte[pos_txt+1]) {
								case 'P':
										aff_image(pos_txt,pos_y,tampon);
										return;
								case 'E':
										aff_pprint(pos_txt,pos_y,tampon);
										return;
								case '-':
										FastestDrawHLine(tampon,pos_y+1);
										return;
								case '=':
										FastestDrawHLine(tampon,pos_y+1);
										FastestDrawHLine(tampon,pos_y+3);
										return;
								case 'L':		//alignement  gauche
								case 'C':		//centr
								case 'R':		//alignement  droite
								case '\\':  //marges
								case ',':
								case ';':
								case '.':
										pos_txt+=2;
										goto format_ligne;
								case '&':  //on veut afficher un &
										pos_txt++;
										goto deb_etude;
								case 'M':  //marge personalise
										caract1=texte[pos_txt+2];
										caract2=texte[pos_txt+3];
										caract3=texte[pos_txt+4];
										if (caract1>='0' && caract1<='9' && caract2>='0' && caract2<='9' && caract3>='0' && caract3<='9') {
												pos_txt+=5;
												goto format_ligne;
										}
						}
				}
		}

//recherche si y'a tout de suite un changement de format: influence sur la hauteur max
format:  //rebouclage : il peut y avoir plusieurs changements de format
		if (texte[pos_txt]=='#') {
				switch (caract2=texte[pos_txt+1]) {
						case '1':  //si on change tout de suite de format
						case '2':	 //modification dj faite  l'tude
						case '3':
						case 'N':
						case 'U':
						case 'J':
						case 'V':
						case 'S':
						case 'I':
						case 'W':
						case 'D':
						case 'E':
								pos_txt+=2;
								goto format;
				}
		}
deb_etude:
		exp_max=HAUT_EXP(format_courant);
	
		while (pos_txt!=ptr_txt[no_ptr+1] && texte[pos_txt]!=13) {  //on est pas encore arriv  la ligne suivante
				caract1=texte[pos_txt++];
				if (caract1=='#') {  //possible formatage...
						caract2=texte[pos_txt++];
						switch (caract2) {
								case '#':  //afficher un dise seulement
										memcpy(&(format_caract[nb_caract]),ptr_format_courant,sizeof(FORMAT));
										caract_pos_txt=nb_caract;
										char_txt[nb_caract++]='#';
										break;
								case '1':
								case '2':
								case '3':
										format_courant.taille1=(((caract2-='1')&0x02)>>1);
										format_courant.taille2=(caract2&0x01);  //changement de police
										if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {
												if (caract2>3-((format_courant.haut_max_indice1)<<1)-format_courant.haut_max_indice2) {
														i=nb_caract;
														while ((format_caract[i].haut_max_indice1 | format_caract[i].haut_max_indice2) && i>=0) {
																format_caract[i].haut_max_indice1=~format_courant.taille1;
																format_caract[i--].haut_max_indice2=~format_courant.taille2;
														}
												}
										}
										break;
								case 'W': //word warp pour la compatibilit avec txtrider
										break;
								case 'U':
										format_courant.souligne=~format_courant.souligne;
										format_courant.pointille=0;
										break;
								case 'N':
										format_courant.pointille=~format_courant.pointille;
										format_courant.souligne=0;
										break;
								case 'J':
										if (format_courant.vecteur && nb_caract>0)	//si on avait un vecteur et un caractre  afficher
												format_caract[caract_pos_txt].conjug=1;		//faire la flche du vecteur
										format_courant.conjug=~format_courant.conjug;
										format_courant.vecteur=0;
										break;
								case 'V':
										if (format_courant.vecteur && nb_caract>0)	//si on avait un vecteur et un caractre  afficher
												format_caract[caract_pos_txt].conjug=1;		//faire la flche du vecteur
										format_courant.vecteur=~format_courant.vecteur;
										format_courant.conjug=0;
										break;
								case 'S':
										format_courant.barre=~format_courant.barre;
										break;
								case 'I':
										format_courant.inverse=~format_courant.inverse;
										break;
								case 'C':
										caract1=texte[pos_txt];
										caract2=texte[pos_txt+1];
										caract3=texte[pos_txt+2];
										if (caract1>='0' && caract1<='9' && caract2>='0' && caract2<='9' && caract3>='0' && caract3<='9') {
												if ((j=(caract3-'0')+10*(caract2-'0')+100*(caract1-'0'))<256) {  //y'a que 255 caractres !
														caract1=j;
														pos_txt+=3;
														goto affnormal;
												}
										}
										pos_txt--;  //saisie incorrecte
										caract1=texte[pos_txt-1];
										goto affnormal;
								case 'E':  //exposant
										if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
												if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
														format_courant.haut_max_indice1=0;  //on passe  l'exposant
														format_courant.haut_max_indice2=0;
														if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
																format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
																format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
																pos_txt+=2;
														}
												} else {  //c'est un exposant
														format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
														format_courant.taille2=~format_courant.haut_exp2;
														format_courant.haut_exp1=0;
														format_courant.haut_exp2=0;
												}
										} else { //y'avais du texte normal : on passe  l'exposant
												format_courant.haut_exp1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'exposant
												format_courant.haut_exp2=~format_courant.taille2;
												if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
														format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
														format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
														pos_txt+=2;
												} else {  //on baisse de police automatiquement
														format_courant.taille2=format_courant.taille1;
														format_courant.taille1=0;
												}
										}
										break;
								case 'D':  //indice
										if (format_courant.haut_exp1 | format_courant.haut_exp2) {  //y'a un format exposant ou indice
												if (format_courant.haut_max_indice1 | format_courant.haut_max_indice2) {  //c'est un indice
														format_courant.taille1=~format_courant.haut_exp1;  //on passe en normal : on remet l'ancienne police
														format_courant.taille2=~format_courant.haut_exp2;
														format_courant.haut_max_indice1=0;
														format_courant.haut_max_indice2=0;
														format_courant.haut_exp1=0;
														format_courant.haut_exp2=0;
												} else {  //c'est un exposant
														format_courant.haut_max_indice1=~format_courant.taille1;
														format_courant.haut_max_indice2=~format_courant.taille2;
												}
										} else {//on tait en normal
												format_courant.haut_exp1=~format_courant.taille1;
												format_courant.haut_exp2=~format_courant.taille2;
												if (texte[pos_txt]=='#' && texte[pos_txt+1]>='1' && texte[pos_txt+1]<='3') {//on change tout de suite de police
														format_courant.taille1=(((texte[pos_txt+1]-'1')&0x02)>>1);
														format_courant.taille2=((texte[pos_txt+1]-'1')&0x01);  //changement de police
														pos_txt+=2;
												} else {  //on baisse de police automatiquement
														format_courant.taille2=format_courant.taille1;
														format_courant.taille1=0;
												}
												format_courant.haut_max_indice1=~format_courant.taille1;  //taille pour dterminer la hauteur d'criture de l'indice
												format_courant.haut_max_indice2=~format_courant.taille2;
										}
										break;
								case 'L':
										no_lien=0;
										while (ptr_liens[no_lien++]!=pos_txt) //on cherche le bon numro de lien
												;
										char_txt[nb_caract] = -no_lien;  //mmorisation en ngatif
										memcpy(&(format_caract[nb_caract++]),ptr_format_courant,sizeof(FORMAT));
										while ( (texte[pos_txt]!='#' || texte[pos_txt+1]!='L') && texte[pos_txt]!=13 && texte[pos_txt]!=0)  //on saute tout le lien
												pos_txt++;
										if (texte[pos_txt++]!=0)
												pos_txt++;
										if (exp_max<10)
												exp_max=10;
										break;
								default:  //pas ce caractre  vocation de mise en page
										pos_txt--;
										goto affnormal;
						}//fin du switch
				} else {  //pas de caractre #: affichage normal
affnormal:
						memcpy(&(format_caract[nb_caract]),ptr_format_courant,sizeof(FORMAT));
						caract_pos_txt=nb_caract;  //pour le vecteur
						char_txt[nb_caract++]=caract1;
				}
				if ((j=HAUT_EXP(format_courant))>exp_max)
						exp_max=j;
		}

		x=pos_x_ligne[no_ptr];
		
		for (j=0;j<nb_caract;j++) {  //affichage caractre par caractre
		
				caract=char_txt[j];
				pos_y_texte=pos_y+exp_max;

				ptr_format_caract=&(format_caract[j]);  //pour viter d'avoir  recalculer

				if (caract<0) {  //c'est un lien
						x+=long_caract;
						caract=-caract-1;
						Sprite8(x,pos_y_texte-10,9,lien_gauche,tampon,A_NORMAL);
						if (caract>9) {
								FastChar(x+4,pos_y_texte-8,'0'+(i=caract/10),tampon,POLICE_1);
								FastChar(x+8,pos_y_texte-8,'0'+caract-10*i,tampon,POLICE_1);
								long_caract=14;
								Sprite8(x+7,pos_y_texte-10,9,lien_droite,tampon,A_NORMAL);
						} else {
								long_caract=12;
								FastChar(x+4,pos_y_texte-8,'0'+caract,tampon,POLICE_1);
								Sprite8(x+3,pos_y_texte-10,9,lien_droite,tampon,A_NORMAL);
						}
						if (ptr_format_caract->souligne | ptr_format_caract->pointille)
								horiz_ligne(x,x+long_caract-(ptr_format_caract->pointille)-1,pos_y_texte,tampon);
						continue;
				}

				police=((ptr_format_caract->taille1)<<1)+ptr_format_caract->taille2;  //idem
				
//changement de hauteur de la ligne de texte
				if (ptr_format_caract->haut_exp1 | ptr_format_caract->haut_exp2)  //on est en exposant
						pos_y_texte-=(val_haut[3-((ptr_format_caract->haut_exp1)<<1)-ptr_format_caract->haut_exp2]>>1);
				if (ptr_format_caract->haut_max_indice1 | ptr_format_caract->haut_max_indice2)  //on est en indice
						pos_y_texte+=val_haut[3-((ptr_format_caract->haut_max_indice1)<<1)-ptr_format_caract->haut_max_indice1];

				FastChar((x+=long_caract),pos_y_texte-val_haut[police],caract,tampon,val_font[police],val_font2[police]);  //dessin du caractre
				
				long_caract=LONGCHAR(ptr_format_caract->taille1,ptr_format_caract->taille2,caract);
				x2=x+long_caract;
				if (ptr_format_caract->barre)
						horiz_ligne(x,x2-1,pos_y_texte-((val_haut[police])>>1)-1,tampon);
				if (ptr_format_caract->souligne | ptr_format_caract->pointille)
						horiz_ligne(x,x2-(ptr_format_caract->pointille)-1,pos_y_texte,tampon);
				if (ptr_format_caract->conjug | ptr_format_caract->vecteur)
						horiz_ligne(x,x2-1,pos_y_texte-val_haut[police]-2,tampon);
				if (ptr_format_caract->conjug & ptr_format_caract->vecteur) {
						aff_pix(x2-2,pos_y_texte-val_haut[police]-3,tampon);
						aff_pix(x2-2,pos_y_texte-val_haut[police]-1,tampon);
				}
				if (ptr_format_caract->inverse)
						inverse(x,x2-1,pos_y,pos_y+haut_ligne[no_ptr],tampon);
		}

}

//=======================================================================================================================
//============================================ Affichage d'une page de texte ============================================
//=======================================================================================================================

unsigned short aff_page(unsigned short no_ptr, short *pos_bas, short *pos_haut, void * ecran) {

		unsigned char y       = 0;                 //position verticale
		unsigned char y2;
		unsigned char * texte = file_txt->texte;

		memset(file_txt->tampon_haut,0,30*file_txt->taille_tampon);  //on efface le tampon du haut
		memset(file_txt->tampon_bas,0,30*file_txt->taille_tampon);   //on efface le tampon du bas
		clrscr();                                                    //on efface l'cran

		aff_ligne(no_ptr,file_txt->tampon_haut,0);  //affichage dans le tampon du haut
		*pos_haut=0;

		while ((y2=y+file_txt->haut_ligne[no_ptr])<=LCD_HEIGHT && texte[file_txt->ptr_txt[no_ptr]]!=0) {  //on affiche sur tout l'cran sauf la dernire ligne (qui dborde)
				aff_ligne(no_ptr++, ecran, y);
				y=y2;
		}

		if (y2>LCD_HEIGHT) {
				aff_ligne(no_ptr,file_txt->tampon_bas,0);  //on affiche la ligne qui dborde dans le tampon du bas

				*pos_bas=LCD_HEIGHT-y-1;  //calcul du dpassement

				memcpy(ecran+30*y,file_txt->tampon_bas,30*(*pos_bas+1));  //copie de la partie de ligne affichable dans l'cran
		} else {
				*pos_bas=file_txt->haut_ligne[--no_ptr];
		}
		return no_ptr;

}

//=======================================================================================================================
//============================================ Affichage de la dernire page ============================================
//=======================================================================================================================

void last_page(short ptr_haut_max, short *ptr_haut, short *ptr_bas, short *pos_haut, short *pos_bas) {

		memset(vscreen,0,LCD_SIZE);  //efface l'cran virtuel
		*ptr_bas=aff_page((*ptr_haut=ptr_haut_max),pos_bas,pos_haut,vscreen);  //affichage dans l'cran virtuel et dans les tampons
		while (*pos_bas<file_txt->haut_ligne[*ptr_bas]-1) {  //si on n'est pas arriv vraiment tout en bas
				defile_haut(vscreen,(++(*pos_bas)));  //on remonte
				pos_haut++;
		}
		memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on affiche le rsultat

}

//=======================================================================================================================
//========================================= Donne le nom du rpertoire du texte =========================================
//=======================================================================================================================

void sym_fold(const unsigned char *str) {
	
		unsigned char name_temp[10];
		SYM_ENTRY     * SymPtr      = NULL;
		unsigned char j             = 0;

//recherche du nom du folder
		while (*str!='\\' && *str)
				name_temp[j++]=(*(str++));

		if (*str=='\\')
				name_temp[j]=0;  //nom donn
		else
				FolderGetCur(name_temp);   //rep courant
		
		SymPtr=SymFindFirst(SYMSTR(name_temp),17);  //recherche de ce rpertoire
		
		file_txt->nom_fold=SymPtr->name;  //on enregistre son pointeur
}

//=======================================================================================================================
//================================ Rempli les donne du texte  partir de son entre Sym ================================
//=======================================================================================================================

unsigned char sym_file(SYM_ENTRY *SymPtr) {
	
		unsigned char  * data   = (unsigned char *)HeapDeref(SymPtr->handle);
		unsigned short longueur = *(unsigned short *)data;
		unsigned char  * data2;
		file_txt->nom_var=SymPtr->name;  //enregistre son nom
		if (data[longueur+1]==OTH_TAG) {  //c'est un zip
#ifdef USE_KERNEL
				longueur=((unsigned short *)data)[6];  //longueur dzipp
				if ((data2=malloc((longueur+5)*sizeof(unsigned char)))==NULL)
						return 0;
				extract(data+4,data2);  //on dcompresse
#else
				if ((data2=decomp(data,&longueur))==NULL)
						return 0;
#endif
				file_txt->texte=data2+2;
				file_txt->typ=2;
		} else {  //c'est un texte
				file_txt->texte=data+4;
				file_txt->typ=1;
		}
		
		
		file_txt->longueur=longueur;
		return 1;
}

//=======================================================================================================================
//============================================= Libre les mmoire octroye =============================================
//=======================================================================================================================

void free_file(void) {
	
		free(file_txt->ptr_txt);
		free(file_txt->format_ligne);
		free(file_txt->pos_x_ligne);
		free(file_txt->haut_ligne);
		free(file_txt->marque_page);
		free(file_txt->ptr_liens);
		if (file_txt->typ==2)//c'tait un zip
				free(file_txt->texte-2);  //on libre ce que l'on a allou pour dcompresser
}

//=======================================================================================================================
//=================================== Donne le numro de la touche du pav numrique ====================================
//=======================================================================================================================

unsigned char key_num(void) {

		while (1) {
				if (K_0) {
						return 0;
				} else if (K_1) {
						return 1;
				} else if (K_2) {
						return 2;
				} else if (K_3) {
						return 3;
				} else if (K_4) {
						return 4;
				} else if (K_5) {
						return 5;
				} else if (K_6) {
						return 6;
				} else if (K_7) {
						return 7;
				} else if (K_8) {
						return 8;
				} else if (K_9) {
						return 9;
				} else if (K_DEL) {
						return 10;
				} else if (K_ENTER) {
						return 11;
				} else if (K_ESC) {
						return 12;
				} else if (K_HOME) {
						off();
				}
		}

}


//=======================================================================================================================
//================================================ Saisie du no du lien =================================================
//=======================================================================================================================

unsigned char choix_lien(void) {
	
		unsigned char key     = 0;
		unsigned char caract1 = '_';  //les deux caractres  afficher
		unsigned char caract2 = ' ';
		unsigned char pos     = 0;
		unsigned char y       = (LCD_HEIGHT>>1)-8;
		unsigned char x       = ((LCD_WIDTH-(LEN_TXT_NUM_LIEN+3)*6)>>1);

aff:
		memset(LCD_MEM+y*30,0,16*30);
		FastestDrawHLine(LCD_MEM,y);
		FastestDrawHLine(LCD_MEM,y+2);
		FastestDrawHLine(LCD_MEM,y+14);
		FastestDrawHLine(LCD_MEM,y+16);
		FastStr(x,y+5,TXT_NUM_LIEN,LCD_MEM,POLICE_2);
		FastChar(x+114,y+5,caract1,LCD_MEM,POLICE_2);
		FastChar(x+120,y+5,caract2,LCD_MEM,POLICE_2);
		
		switch (key=key_num()) {
				case 12:  //[ESC]
						return 0;
				case 11:  //[ENTER]
						if (caract1=='_')
								return 0;  //on a rien rentr
						if (caract2=='_')
								return caract1-'0'+1;  //juste un chiffre
						return 10*(caract1-'0')+(caract2-'0')+1;  //un nombre
				case 10:  //[DEL]
						if (pos==0)
								break;
						pos--;
						if (pos==0) {
								caract1='_';
								caract2=' ';
						} else
								caract2='_';
						break;
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9:
						if (pos==2)
								break;
						pos++;
						if (pos==2)
								caract2='0'+key;
						else {
								caract1='0'+key;
								caract2='_';
						}
		}
		wait(vit_menu);
		goto aff;
}

//=======================================================================================================================
//============================================ Affichage des bordure d'cran ============================================
//=======================================================================================================================

void bordure(void *ecran, unsigned char titre) {
	
		FastestDrawHLine(ecran,0);
		FastestDrawHLine(ecran,2);
		FastestDrawHLine(ecran,LCD_HEIGHT-1);
		FastestDrawHLine(ecran,LCD_HEIGHT-3);
		FastestDrawHLine(ecran,titre);
		FastestDrawHLine(ecran,titre+2);
		DrawVertLine(0,0,LCD_HEIGHT,ecran);
		DrawVertLine(2,0,LCD_HEIGHT,ecran);
		DrawVertLine(LCD_WIDTH-1,0,LCD_HEIGHT,ecran);
		DrawVertLine(LCD_WIDTH-3,0,LCD_HEIGHT,ecran);

}

//=======================================================================================================================
//======================================== Efface les doublons dans l'historique ========================================
//=======================================================================================================================

void del_double() {
		unsigned char j;
		unsigned char i;
		unsigned char k;
		
		for (j=0;j<historique->nb-1;j++) {
				for (i=j+1;i<historique->nb;i++) {
//disp("i,j=%d,%d",i,j)
						if ( strcmp(historique->tab_var+19*j,historique->tab_var+19*i)!=0  //vrifie le repertoire
																						|| strcmp(historique->tab_var+19*j+9,historique->tab_var+19*i+9)!=0  //vrifie le nom
																						|| *(historique->tab_var+19*j+18)!=*(historique->tab_var+19*i+18) )  //vrifie le marque page
								continue;
						for (k=i;k<historique->nb-1;k++)  //effacement par dplacement de la liste
								memcpy(historique->tab_var+19*k,historique->tab_var+19*k+19,19);
						historique->nb--;
						i--;
				}
		}
}

//=======================================================================================================================
//================================================= Deplace un favoris ==================================================
//=======================================================================================================================

void deplace_fav(unsigned char fav_dest, unsigned char fav_scr) {
		unsigned char buffer[20];
		signed char sens;
		unsigned char j=fav_scr-1;
		
		memcpy(buffer,favoris->tab_var+19*j,19);
		sens=( (fav_dest>fav_scr) ? 1 : -1 );
		for (;j!=fav_dest-1;j+=sens)
				memcpy(favoris->tab_var+19*j,favoris->tab_var+19*(j+sens),19);
		memcpy(favoris->tab_var+19*j,buffer,19);
}

//=======================================================================================================================
//============================================== Routine de menu de choix ===============================================
//=======================================================================================================================

unsigned char choix(TAB_TXT * tab, const unsigned char titre[], const unsigned char * nom_var, unsigned char menu) {

		unsigned char y;

		unsigned char deplace    = 0;
		unsigned char no_deplace = 0;

		short         no       = 1;                        //numero en tude
		short         deb      = 1;                        //no de celui qui est en haut de l'cran
		unsigned char i,j;
		short         no_choix = 1 ;                        //no choisi
		unsigned char y0       = 9;
		unsigned char nb_aff   = ( CALCULATOR ? 12 : 9 );  //nb que l'on peut afficher
		
		unsigned char chartemp[20];
		
		if (menu!=0) { //marque-page  !=   favoris et historique   
				y0=19;
				nb_aff--;
		}
aff:  //boucle d'affichage
		wait(vit_menu);
		if (no_choix>tab->nb)
				no_choix=tab->nb;
		if (no_choix==0)
				no_choix=1;
		if (deb+nb_aff>tab->nb)
				deb--;
		if (deb==0)
				deb=1;				
		no=deb;
		clrscr();
		bordure(LCD_MEM,13);
		FastStr(((LCD_WIDTH-6*strlen(titre))>>1),4,titre,LCD_MEM,POLICE_2);  //affichage du titre

		if (menu!=0) {
				FastestDrawHLine(LCD_MEM,23);
				FastestDrawHLine(LCD_MEM,25);
				if (menu==1) {  //affichage du menu de Favoris
						FastStr(4,17,TXT_F1_DEP,LCD_MEM,POLICE_1);
						if (tab->nb<2) {  //pas de dplacement possible: on efface cette possibilit
								del_ligne(4,8,18,LCD_MEM);
								memset(LCD_MEM+18*30+1,0,5);
								del_ligne(4,8,20,LCD_MEM);
								memset(LCD_MEM+20*30+1,0,5);
						}
						DrawVertLine(45,13,25,LCD_MEM);
						DrawVertLine(47,13,25,LCD_MEM);
						if (nom_var!=NULL) {
								FastStr(49,17,TXT_F2_AJOU,LCD_MEM,POLICE_1);
								FastStr(49+LEN1_TXT_F2_AJOU,17,nom_var,LCD_MEM,POLICE_1);
						}
				} else {
						FastStr(4,17,TXT_F1_SUPP,LCD_MEM,POLICE_1);
						if (tab->nb<2) {  //pas de doublons possible: on efface cette possibilit
								del_ligne(4,8,18,LCD_MEM);
								memset(LCD_MEM+18*30+1,0,9);
								del_ligne(80,81,18,LCD_MEM);
								del_ligne(4,8,20,LCD_MEM);
								memset(LCD_MEM+20*30+1,0,9);
								del_ligne(80,81,20,LCD_MEM);
						}
						DrawVertLine(4+LEN1_TXT_F1_SUPP,13,25,LCD_MEM);
						DrawVertLine(6+LEN1_TXT_F1_SUPP,13,25,LCD_MEM);
				}
		}

		if (tab->nb!=0) {
				FastChar(4,y=((no_choix-deb)<<3)+8+y0,22,LCD_MEM,POLICE_2);  //affichage de la flche
				if (deplace)  //on inverse la couleur de la flche si on veut dplacer un favoris
						inverse(4,10,y,y+6,LCD_MEM);
				y=y0;
				while (no<=tab->nb && no-deb<=nb_aff) { //si y'en a encore et l'cran est assez grand
						if (menu==0) {
								FastStr(10,(y+=8),&(tab->tab_var[40*((no++)-1)]),LCD_MEM,POLICE_2);
						} else {
								if ((i=tab->tab_var[19*no-1])!=0) { //y'a un marque page de spcifi
										sprintf(chartemp,"%s\\%s (%d)",&(tab->tab_var[19*no-19]),&(tab->tab_var[19*no-10]),i-1);
								} else {
										sprintf(chartemp,"%s\\%s",&(tab->tab_var[19*no-19]),&(tab->tab_var[19*no-10]));
								}
								FastStr(12,(y+=8),chartemp,LCD_MEM,POLICE_2);
								no++;
						}
				}


		} else {
		 		FastStr(((LCD_WIDTH-LEN_TXT_VIDE*6)>>1),((LCD_HEIGHT+7)>>1),TXT_VIDE,LCD_MEM,POLICE_2);  //(lcd-15)/2+15-4 = (lcd+7)/2
		}
touche:
		if (K_BAS && tab->nb!=0) {
				no=no_choix;
				if (K_DIAM) {
						deb=tab->nb-nb_aff;
						if (deb<1)
								deb=1;
						no_choix=tab->nb;
				} else if (K_2ND) {  //on avance d'une page
						deb+=nb_aff;
						no_choix+=nb_aff;
						if (deb+nb_aff>tab->nb) {//on dpasse
								deb=tab->nb-nb_aff;
								if (deb<1)
										deb=1;
								if (no_choix>tab->nb)
										no_choix=tab->nb;
						}
				} else {
						if (no_choix<tab->nb) {
								no_choix++;  //on passe au suivant
								if (no_choix-deb>nb_aff)  //on dpasse l'cran
										deb++;
						} else {  //on repasse au dbut
								deb=1;
								no_choix=1;
						}
				}
				if (deplace)
						deplace_fav(no_choix,no);
				goto aff;
		} else if (K_HAUT && tab->nb!=0) {
				no=no_choix;
				if (K_DIAM) {
						deb=1;
						no_choix=1;
				} else if (K_2ND) {//on recule d'une page
						deb-=nb_aff;
						no_choix-=nb_aff;
						if (deb<1) {  //on dpasse
								deb=1;
								if (no_choix<1)
										no_choix=1;
						}
				} else {
						if (no_choix>1) {
								no_choix--;
								if (no_choix<deb)
										deb--;
						} else {  //on repasse  la fin
								deb=tab->nb-nb_aff;
								if (deb<1)
										deb=1;
								no_choix=tab->nb;
						}
				}
				if (deplace)
						deplace_fav(no_choix,no);
				goto aff;
		} else if (K_ENTER && tab->nb!=0) {		//[ENTER] : on en a choisi un
				if (deplace) {
						deplace=0;
						goto aff;
				}
				return no_choix;
		} else if	(K_ESC) {  //[ESC] : on a rien choisi
				if (deplace) {
						deplace_fav(no_deplace,no_choix);
						deplace=0;
						no_choix=no_deplace;
						if (no_choix<deb)
								deb=no_choix;
						if (no_choix-deb>nb_aff)
								deb=no_choix-nb_aff;
						goto aff;
				}
				wait(vit_menu);
				return 0;
		} else if (K_HOME) {  //[HOME]: on teint
				off();
 		} else if (K_PLUS && K_DIAM) {
				OSContrastUp();
				wait(vit_menu);
 		} else if (K_MOINS && K_DIAM) {
 				OSContrastDn();
				wait(vit_menu);
		} else if (K_F1 && tab->nb>1) {
				switch (menu) {
						case 1: //option dplacer pour favoris
								deplace=1;
								no_deplace=no_choix;
								break;
						case 2:  //supprimer les doublons
								if (confirm_del_dbl) {
										message(TXT_SUPPR_DBL);
										while (1) {
												if (K_ENTER) {
														break;
												} else if (K_ESC) {
														goto aff;
												}
										}
								}
								del_double();
								break;
						default :
								goto touche;
				}
				goto aff;
		} else if (K_F2 && nom_var!=NULL && !deplace) {//fonction ajout pour favoris
				if ((augment_taille((void * *)&(favoris->tab_var),favoris->nb,2,19*sizeof(unsigned char)))==0) {
						message(TXT_MQ_MEM2);
						pause();
						goto aff;
				}
				favoris->nb++;
				j=0;
				i=19;
				while (nom_var[j]!='\\')  //recopie du nom de dossier
						favoris->tab_var[favoris->nb*19-(i--)]=nom_var[j++];
				favoris->tab_var[favoris->nb*19-i]=0;
				i=10;
				while (nom_var[++j]!=0)  //recopie du nom du fichier
						favoris->tab_var[favoris->nb*19-(i--)]=nom_var[j];
				favoris->tab_var[favoris->nb*19-i]=0;
				goto aff;
		} else if (K_DEL && tab->nb!=0 && !deplace && menu!=0) {
				if (confirm_del) {
						message(TXT_SUPPR_ENTRE);
						while (1) {
								if (K_ENTER) {
										break;
								} else if (K_ESC) {
										goto aff;
								}
						}
				}
				for (j=no_choix;j<tab->nb;j++)
						memcpy(tab->tab_var+19*j-19,tab->tab_var+19*j,19);
				tab->nb--;				
				goto aff;
		}
		goto touche;
	

}

//=======================================================================================================================
//================================== Affichage et choix de la liste des marques pages ===================================
//=======================================================================================================================

unsigned char aff_marque_page(void) {
		
		TAB_TXT tab_marq;
		short         no=0;                            //no du marque page en etude
		
//variable du texte
		unsigned char * texte       = file_txt->texte;
		short         * marque_page = file_txt->marque_page;

		unsigned char       caract;                                 //caractre  afficher
		unsigned short      ptr_caract;                             //case du caractre dans le texte
		unsigned char       nb_caract  = 0;                         //nombre de caractre
		unsigned char       nb_aff     = ( CALCULATOR ? 37 : 24 );  //nombre de caractre que l'on peut afficher

		if (file_txt->nb_marque==0) {  //pas de marque page
				clrscr();
				bordure(LCD_MEM,13);
				FastStr(((LCD_WIDTH-LEN_TXT_MARQ_P*6)>>1),4,TXT_MARQ_P,LCD_MEM,POLICE_2);
				FastStr(((LCD_WIDTH-LEN_TXT_NO_MARQ*6)>>1),(LCD_HEIGHT>>1),TXT_NO_MARQ,LCD_MEM,POLICE_2);
				pause();
				return 0;
		}

		if ((tab_marq.tab_var=malloc(file_txt->nb_marque*40*sizeof(unsigned char)))==NULL)
				return 0;

		while (no<file_txt->nb_marque) {  //tant qu'y'a des marque page
				ptr_caract=file_txt->ptr_txt[marque_page[no]]-1;
				nb_caract=0;
				if ((caract=texte[ptr_caract])=='&') {  //on saute les caractres  vocation de mise en page
						switch (texte[ptr_caract+1]) {
								case 'L':    //caractre du type format
								case 'C':
								case 'R':
										ptr_caract+=2;		//on l'ignore
//  que faire si on tombe sur &P, &- ou &= ??  je laisse comme a... bof
//  txtrider ne le prend pas du tout en compte le marque page: je trouve ca dommage....
						}
				}
				ptr_caract++;
				while (nb_caract<nb_aff && texte[ptr_caract]!=13) {  //affichage caractre par caractre
						if ((caract=texte[ptr_caract])=='#') {
								switch (texte[ptr_caract+1]) {
										case '1':  //caractre de type format
										case '2':
										case '3':
										case 'I':
										case 'N':
										case 'U':
										case 'J':
										case 'V':
										case 'E':
										case 'D':
										case 'C':
										case 'R':
												ptr_caract++;		//on l'ignore
												break;
										case 'L': //lien : faut sauter tout le lien
												ptr_caract++;
												while ( (texte[ptr_caract]!='#' || texte[ptr_caract+1]!='L') && texte[ptr_caract]!=13 && texte[ptr_caract]!=0)
														ptr_caract++;
												if (texte[ptr_caract]!=0)
														ptr_caract++;
												break;
										default:	//sinon affichage normal
												goto affnormal;
								} 
						} else {
affnormal:
								tab_marq.tab_var[40*no+(nb_caract++)]=caract;
						}
						ptr_caract++;
				}
				tab_marq.tab_var[40*(no++)+nb_caract]=0;
		}

		tab_marq.nb=file_txt->nb_marque;
		no=choix(&tab_marq,TXT_MARQ_P,NULL,0);
		free(tab_marq.tab_var);
		
		if (no==0)
				return 0;

		return file_txt->marque_page[no-1]+1;

}

//=======================================================================================================================
//================================================ Affichage des options ================================================
//=======================================================================================================================

unsigned char aff_option(void) {

		unsigned char strtemp[6];
		unsigned char pos_x      = LCD_WIDTH-20;
		unsigned char pos_y      = 0;
		unsigned char j;

//variable qui stocke les valeurs temporaires
		unsigned char nb_max    = max_hist;
		unsigned char defil     = vit_defil;
		unsigned char menu      = vit_menu;
		unsigned char del_dbl   = auto_del_dbl;
		unsigned char quit      = auto_quit;
		unsigned char c_del     = confirm_del;
		unsigned char c_del_dbl = confirm_del_dbl;
		
		unsigned char tab_pos_y[]=VAL_POS_TXT;

		unsigned char * hist2 = NULL;  //pour le changement de taille

aff:
		wait(vit_menu);
		//memset(vscreen,0,LCD_SIZE);
		clrscr();
		bordure(LCD_MEM,13);
		FastStr(((LCD_WIDTH-LEN_TXT_OPT*6)>>1),4,TXT_OPT,LCD_MEM,POLICE_2);

		AFF_TXT_HIST_MAX
		sprintf(strtemp,"%c%2d%c",25,nb_max,26);  //25 et 26 : les grosses flches
		FastStr(pos_x,POS_TXT_HIST_MAX,strtemp,LCD_MEM,POLICE_1);
		for (j=LEN_TXT_HIST_MAX;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_HIST_MAX+4,LCD_MEM);
		
		AFF_TXT_VIT_MENU
		sprintf(strtemp,"%c%2d%c",25,VIT_MENU_MAX-menu,26);  //25 et 26 : les grosses flches
		FastStr(pos_x,POS_TXT_VIT_MENU,strtemp,LCD_MEM,POLICE_1);
		for (j=LEN_TXT_VIT_MENU;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_VIT_MENU+4,LCD_MEM);

		AFF_TXT_VIT_DEFIL
//		sprintf(strtemp,"%c%2d%c",25,VIT_DEFIL_MAX-defil,26);  //25 et 26 : les grosses flches
		sprintf(strtemp,"N/A");
		FastStr(pos_x,POS_TXT_VIT_DEFIL,strtemp,LCD_MEM,POLICE_1);
		for (j=LEN_TXT_VIT_DEFIL;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_VIT_DEFIL+4,LCD_MEM);

		AFF_TXT_AUTO_DEL_DBL
		FastStr(pos_x,POS_TXT_AUTO_DEL_DBL,(del_dbl?TXT_OUI:TXT_NON),LCD_MEM,POLICE_1);
		for (j=LEN_TXT_AUTO_DEL_DBL;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_AUTO_DEL_DBL+4,LCD_MEM);

		AFF_TXT_AUTO_QUIT
		FastStr(pos_x,POS_TXT_AUTO_QUIT,(quit?TXT_OUI:TXT_NON),LCD_MEM,POLICE_1);
		for (j=LEN_TXT_AUTO_QUIT;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_AUTO_QUIT+4,LCD_MEM);

		AFF_TXT_CONF_DEL
		FastStr(pos_x,POS_TXT_CONF_DEL,(c_del?TXT_OUI:TXT_NON),LCD_MEM,POLICE_1);
		for (j=LEN_TXT_CONF_DEL;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_CONF_DEL+4,LCD_MEM);

		AFF_TXT_CONF_DEL_DBL
		FastStr(pos_x,POS_TXT_CONF_DEL_DBL,(c_del_dbl?TXT_OUI:TXT_NON),LCD_MEM,POLICE_1);
		for (j=LEN_TXT_CONF_DEL_DBL;j<pos_x-1;j+=2)
				aff_pix(j,POS_TXT_CONF_DEL_DBL+4,LCD_MEM);

		FastChar(4,tab_pos_y[pos_y],22,LCD_MEM,POLICE_1);

		//memcpy(LCD_MEM,vscreen,LCD_SIZE);
//on inverse la couleur de l'option courante
/*		inverse(pos_x-1,pos_x+6,pos_y-1,pos_y+8,LCD_MEM);
		inverse(pos_x+7,pos_x+14,pos_y-1,pos_y+8,LCD_MEM);
		inverse(pos_x+15,pos_x+22,pos_y-1,pos_y+8,LCD_MEM);*/

touche:
		if (K_BAS) {
				if (pos_y!=6)
						pos_y++;
				else
						pos_y=0;
				goto aff;
		} else if (K_HAUT) {
				if (pos_y!=0)
						pos_y--;
				else
						pos_y=6;
				goto aff;
		} else if (K_DROITE) {  //on augmente les valeurs
				if (pos_y==0) { //nb_max
						nb_max++;
				} else if (pos_y==1) {
						if (menu>VIT_MENU_MIN)
								menu--;
						else
								menu=VIT_MENU_MAX;
				} else if (pos_y==2) {
						goto touche;
/*						if (defil>VIT_DEFIL_MIN)
								defil--;
						else
								defil=VIT_DEFIL_MAX;
*/
				} else if (pos_y==3) {
						del_dbl=1-del_dbl;
				} else if (pos_y==4) {
						quit=1-quit;
				} else if (pos_y==5) {
						c_del=1-c_del;
				} else if (pos_y==6) {
						c_del_dbl=1-c_del_dbl;
				}
				goto aff;
		} else if (K_GAUCHE) {  //on diminue les valeurs
				if (pos_y==0) { //nb_max
						if (nb_max>HIST_NB_MAX_MIN)
								nb_max--;
				} else if (pos_y==1) {
						if (menu<VIT_MENU_MAX)
								menu++;
						else
								menu=VIT_MENU_MIN;
				} else if (pos_y==2) {
						goto touche;
/*						if (defil<VIT_DEFIL_MAX)
								defil++;
						else
								defil=VIT_DEFIL_MIN;
*/
				} else if (pos_y==3) {
						del_dbl=1-del_dbl;
				} else if (pos_y==4) {
						quit=1-quit;
				} else if (pos_y==5) {
						c_del=1-c_del;
				} else if (pos_y==6) {
						c_del_dbl=1-c_del_dbl;
				}
				goto aff;
		} else if (K_ENTER) {  //on quitte et on enregistre
				if (max_hist!=nb_max) {  //changement de taille de l'historique
						if ((hist2=malloc(nb_max*19*sizeof(unsigned char)))==NULL)
								return 0;
						if (historique->nb>nb_max) //on rduit le nombre d'historique
								historique->nb=nb_max;
						memcpy(hist2,historique->tab_var,historique->nb*19*sizeof(unsigned char));
						free(historique->tab_var);
						historique->tab_var=hist2;
						max_hist=nb_max;
				}
				vit_defil=defil;
				vit_menu=menu;
				auto_del_dbl=del_dbl;
				auto_quit=quit;
				confirm_del=c_del;
				confirm_del_dbl=c_del_dbl;
				return 1;
		} else if (K_ESC) {  //on quitte sans rien enregistrer
				return 1;
		} else if (K_HOME) {  //[HOME]: on teint
				off();
 		} else if (K_PLUS && K_DIAM) {
				OSContrastUp();
				wait(vit_menu);
 		} else if (K_MOINS && K_DIAM) {
 				OSContrastDn();
				wait(vit_menu);
		}
		goto touche;

}

//=======================================================================================================================
//============================================= Affichage de "a propos de" ==============================================
//=======================================================================================================================

void aff_aproposde(void) {
		clrscr();
		bordure(LCD_MEM,13);
		FastStr(((LCD_WIDTH-LEN_TXT_APROPOSDE*6)>>1),4,TXT_APROPOSDE,LCD_MEM,POLICE_2);
		FastStr(5,18,TXT_VERSION,LCD_MEM,POLICE_1);
		FastStr(5,28,TXT_PROG,LCD_MEM,POLICE_1);
		FastStr(10,36,"hibou : hibou@bonbon.net",LCD_MEM,POLICE_1);
		FastStr(5,46,TXT_MERCI,LCD_MEM,POLICE_1);
		FastStr(10,54,TXT_TICT,LCD_MEM,POLICE_1);
		FastStr(10,62,TXT_TIGCC,LCD_MEM,POLICE_1);
		FastStr(10,70,"Franois Lieber",LCD_MEM,POLICE_1);
		FastStr(10,78,TXT_TCI,LCD_MEM,POLICE_1);
		pause();
		if (K_6 && K_4) {  //c'est perso....
				clrscr();
				FastStr(((LCD_WIDTH-18*6)>>1),((LCD_HEIGHT+7)>>1)," ma petite bio...",LCD_MEM,POLICE_2);   //(lcd-15)/2+15-4 = (lcd+7)/2
				wait(100);
		}
}

//=======================================================================================================================
//============================================== Vrifie si c'est un texte ==============================================
//=======================================================================================================================

unsigned char is_txt(SYM_ENTRY * SymPtr) {
		unsigned char  * data;
		unsigned short longueur;
	
		data=(char *)HeapDeref(SymPtr->handle);
		longueur=*(unsigned short *)data;

		if (data[longueur+1]==TEXT_TAG)  //c'est un texte
				return 1;
		if (data[longueur+1]==OTH_TAG) {  //peut-etre un zip
#ifdef USE_KERNEL
				if (strcmp(&(data[longueur-3]),"ZIP")==0 && data[2]==0x07)//texte compress
						return 2;
#else
				if (strcmp(&(data[longueur-4]),"KOMP")==0)//texte compress
						return 2;
#endif
		}
		return 0;
}

//=======================================================================================================================
//============================== Rempli les tableaux de tous les textes prsents sur la Ti ==============================
//=======================================================================================================================

short init_tab_txt(SYM_ENTRY * * *folder, SYM_ENTRY * * * *ptr_tab_txt, unsigned short * *tab_nb_txt, unsigned char * * *tab_typ) {

//variables de recherche	
		SYM_ENTRY     * SymPtr;
		unsigned char typ;
		
		SYM_ENTRY      * * folder2;            // pour changement de taille
		unsigned short taille_var = 10;
		unsigned short nb_folder;
	
		SYM_ENTRY      * * tab_txt;  //tableau de pointeur de Sym des textes d'un rpertoire
		unsigned char  * typ_txt;  //tableau des types des texte d'un rpertoire
		unsigned short nb_txt;
		
		unsigned short i,j;  //variables de boucles

		unsigned char name_temp[10]; //pour convertir les noms des folder et fichier

		if ((*folder=malloc(10*sizeof(SYM_ENTRY *)))==NULL)
				return 0;
	
//recherche de tout les dossiers (pas les dossiers temporaires)
		(*folder)[0]=SymFindFirst(NULL,4);  //y'a au moins un repertoire (main)
		nb_folder=1;
		while ((SymPtr=SymFindNext())!=NULL) {
				(*folder)[nb_folder++]=SymPtr;
				if (nb_folder>=taille_var) {  //si le tableau n'est plus assez grand
						taille_var+=5;
						if ((folder2=malloc(taille_var*sizeof(SYM_ENTRY *)))==NULL) {
								free(*folder);
								return 0;
						}
		/*				for (j=0;j<nb_folder;j++)
								folder2[j]=(*folder)[j];*/
						memcpy(folder2,*folder,nb_folder*sizeof(SYM_ENTRY *));
						free(*folder);
						*folder=folder2;
				}
		}
	
		*ptr_tab_txt=malloc(nb_folder*sizeof(SYM_ENTRY * * *));
		*tab_nb_txt=malloc(nb_folder*sizeof(unsigned short));
		*tab_typ=malloc(nb_folder*sizeof(unsigned char * *));

//recherche des textes pour chaque rpertoire
		for (j=0;j<nb_folder;j++) {
				nb_txt=0;
				taille_var=1;
				tab_txt=malloc(sizeof(SYM_ENTRY *));  //je peux quand mme supposer qu'il y aura assez de mmoire...
				typ_txt=malloc(sizeof(unsigned char));
				name_temp[0]=0;
				SymPtr=SymFindFirst(strcpy(name_temp+1,(*folder)[j]->name)+strlen((*folder)[j]->name),1);  //recherche tous les fichiers du rpertoire
				while (SymPtr!=NULL) {
						if ((typ=is_txt(SymPtr))!=0) {
								if (nb_txt>=taille_var) {  //tableaux plus assez grand
										if ((augment_taille((void * *)(&tab_txt),taille_var,10,sizeof(SYM_ENTRY *)))==0)
												goto mem;
										if ((augment_taille((void * *)(&typ_txt),taille_var,10,sizeof(unsigned char)))==0)
												goto mem;
										taille_var+=10;
								}
								typ_txt[nb_txt]=typ;  //sauvegarde du type et du pointeur sym du texte
								tab_txt[nb_txt++]=SymPtr;
						}
						SymPtr=SymFindNext();  //au suivant
				}

				(*tab_nb_txt)[j]=nb_txt;  //mmorisation des valeurs et des pointeurs de tableau
				(*ptr_tab_txt)[j]=tab_txt;
				(*tab_typ)[j]=typ_txt;

		}

		return nb_folder;

mem:  //pb de mmoire : faut tout librer
		free(tab_txt);
		free(typ_txt);
		for (i=0;i<j;i++) {
				free(ptr_tab_txt[j]);
				free(tab_typ[j]);
		}
		free(tab_nb_txt);
		free(ptr_tab_txt);
		free(tab_typ);
		free(folder);
		return 0;
}


//=======================================================================================================================
//============================================= Affichage du menu principal =============================================
//=======================================================================================================================


unsigned char menu(short *marq, SYM_ENTRY * * SymPtr) {

		SYM_ENTRY     * * folder = NULL;  //tableau de pointeur sym des folders
		unsigned char nb_folder  = 0;
	
		SYM_ENTRY      * * * ptr_tab_txt = NULL;  //tableau de tableau de pointeurs Symptr de textes  => ptr_tab_txt[no_folder][no_texte] =  * symptr_txt
		unsigned char  * * tab_typ       = NULL;
		unsigned short * tab_nb_txt      = NULL;  //tableau  de nb de texte par rpertoire

		unsigned char        y;                 //position d'affichage
		static unsigned char no_fold      = 0;  //repertoire courant
		static unsigned char no_txt       = 0;  //texte courant
		unsigned char        nb_txt;
		static unsigned char col          = 0;  //on choisi le texte ou le folder
		static unsigned char fold_1       = 0;  //no du folder  afficher en premier
		static unsigned char txt_1        = 0;  //no du texte  afficher en premier
//unsigned char j;  ca plante tigcc ???
		short                j;
		unsigned char        name_var[20];
		unsigned char        max_ligne    = ( CALCULATOR ? 13 : 10 );

		if ((nb_folder=init_tab_txt(&folder,&ptr_tab_txt,&tab_nb_txt,&tab_typ))==0)
				return 0;  //problme de mmoire

		nb_txt=tab_nb_txt[no_fold];
		*SymPtr=NULL;

aff:
		memset(vscreen,0,LCD_SIZE);
//affichage des folders
		j=fold_1;
		y=7;
		while (j-fold_1<max_ligne && j<nb_folder)
				FastStr(14,(y+=8),folder[j++]->name,vscreen,POLICE_2);

//affichage des textes
		if (nb_txt==0) {
				FastStr((LCD_WIDTH>>1)+4,15,TXT_NO_TXT,vscreen,POLICE_2);
		} else {
				j=txt_1;
				y=7;
				while (j-txt_1<max_ligne && j<nb_txt) {
						FastStr((LCD_WIDTH>>1)+13,(y+=8),ptr_tab_txt[no_fold][j]->name,vscreen,POLICE_2);
						if (tab_typ[no_fold][j++]==2)  //c'est un zip
								FastStr((LCD_WIDTH>>1)+64,y+2,"(z)",vscreen,POLICE_1);
				}
		}
//affichage de la flche
		FastChar(6,15+8*(no_fold-fold_1),22,vscreen,POLICE_2);
		if (col)
				FastChar((LCD_WIDTH>>1)+5,15+8*(no_txt-txt_1),22,vscreen,POLICE_2);
//affichage du reste
		bordure(vscreen,10);
		DrawVertLine((LCD_WIDTH>>1)+1,10,LCD_HEIGHT,vscreen);
		DrawVertLine((LCD_WIDTH>>1)-1,10,LCD_HEIGHT,vscreen);
		
		y=LCD_WIDTH/5;
		
		FastStr(((y-LEN1_TXT_FAV)>>1)+1,4,TXT_FAV,vscreen,POLICE_1);
		DrawVertLine(y-1,0,12,vscreen);
		DrawVertLine(y+1,0,12,vscreen);
		FastStr(((3*y-LEN1_TXT_HIST)>>1)+1,4,TXT_HIST,vscreen,POLICE_1);
		DrawVertLine(2*y-1,0,12,vscreen);
		DrawVertLine(2*y+1,0,12,vscreen);
#ifdef USE_KERNEL
		FastStr(((5*y-9)>>1)+1,4,"Zip",vscreen,POLICE_1);
#else
		FastStr(((5*y-18)>>1)+1,4,"Komp",vscreen,POLICE_1);
#endif
		DrawVertLine(3*y-1,0,12,vscreen);
		DrawVertLine(3*y+1,0,12,vscreen);
		FastStr(((7*y-LEN1_TXT_OPT)>>1)+1,4,TXT_OPT,vscreen,POLICE_1);
		DrawVertLine(4*y-1,0,12,vscreen);
		DrawVertLine(4*y+1,0,12,vscreen);
		FastStr(((9*y-LEN1_TXT_AIDE)>>1)+1,4,TXT_AIDE,vscreen,POLICE_1);



		memcpy(LCD_MEM,vscreen,LCD_SIZE);

touche:
		if (K_BAS) {  //[BAS]
				if (col) {  //on est dans les textes
						if ((++no_txt)==nb_txt) { //on est tout en bas
								no_txt=0;
								txt_1=0;
						}
						if (no_txt-txt_1>=max_ligne)  //on dplace le tout
								txt_1++;
				} else {
						if ((++no_fold)==nb_folder) {  //on est tout en bas
								no_fold=0;
								fold_1=0;
						}
						if (no_fold-fold_1>=max_ligne)  //on dplace le tout
								fold_1++;
						txt_1=0;
						no_txt=0;
						nb_txt=tab_nb_txt[no_fold];
				}
		} else if (K_HAUT) {  //[HAUT]
				if (col) {  //on est dans les textes
						if (no_txt==0) { //on est tout en haut
								no_txt=nb_txt;
								txt_1=( (nb_txt-max_ligne>0) ? (nb_txt-max_ligne) : 0 );
						}
						if ((no_txt--)-txt_1==0)  //on dplace le tout
								txt_1--;
				} else {
						if (no_fold==0) { //on est tout en haut
								no_fold=nb_folder;
								fold_1=( (nb_folder-max_ligne>0) ? (nb_folder-max_ligne) : 0 );
						}
						if ((no_fold--)-fold_1==0)  //on dplace le tout
								fold_1--;
						txt_1=0;
						no_txt=0;
						nb_txt=tab_nb_txt[no_fold];
				}
		} else if (!(col) && (K_DROITE || K_ENTER) && nb_txt!=0) {  //[DROITE] ou [ENTER] on passe dans les textes si y'en a
				col++;
		} else if	(col && (K_GAUCHE || K_ESC)) {  //[GAUCHE] ou [ESC] on passe dans les folders
				col--;
		} else if (!(col) && K_ESC) {  //[ESC] on quitte
				*SymPtr=NULL;
				goto fin;
		} else if (col && K_ENTER) {  //[ENTER] on a choisi notre texte
				file_txt->nom_fold=folder[no_fold]->name;
				*SymPtr=ptr_tab_txt[no_fold][no_txt];
				goto fin;
		} else if (K_HOME) {  //[HOME]
				off();
				goto touche;
 		} else if (K_PLUS && K_DIAM) {
				OSContrastUp();
				wait(vit_menu);
				goto touche;
 		} else if (K_MOINS && K_DIAM) {
 				OSContrastDn();
				wait(vit_menu);
 				goto touche;
 		} else if (K_F1) {
 				if (col)
 						sprintf(name_var,"%s\\%s",folder[no_fold]->name,ptr_tab_txt[no_fold][no_txt]->name);
				if ((j=choix(favoris, TXT_FAV, ((col) ? name_var : NULL),1))!=0) {
						j--;
						sprintf(name_var,"%s\\%s",&(favoris->tab_var[19*j]),&(favoris->tab_var[19*j+9]));  //concatnation des noms
						if ((*SymPtr=DerefSym(SymFind(SYMSTR(name_var))))!=NULL) {  //recherche
								if (is_txt(*SymPtr)!=0) {
										memset(file_txt,0,sizeof(FILE_TXT));  //on efface tout
										*marq=(-favoris->tab_var[19*j+18]);  //pour retourner le no du marque page
										file_txt->nom_fold=SymFindFirst(SYMSTR(&(favoris->tab_var[19*j])),17)->name;
										goto fin;  //retourne le symptr du texte
								}
						}
						goto no_txt;
				}
 		} else if (K_F2) {
				if ((j=choix(historique, TXT_TIT_HIST,NULL,2))!=0) {
						j--;
						sprintf(name_var,"%s\\%s",&(historique->tab_var[19*j]),&(historique->tab_var[19*j+9]));  //concatnation des noms
						if ((*SymPtr=DerefSym(SymFind(SYMSTR(name_var))))!=NULL) {  //recherche
								if (is_txt(*SymPtr)!=0) {
										memset(file_txt,0,sizeof(FILE_TXT));  //on efface tout
										*marq=(-historique->tab_var[19*j+18]);  //pour retourner le no du marque page
										file_txt->nom_fold=SymFindFirst(SYMSTR(&(historique->tab_var[19*j])),17)->name;
										goto fin;  //retourne le symptr du texte
								}
						}
no_txt:						//pas de texte
						message(TXT_NO_REC);
						pause();
				}
 		} else if (K_F3 && col) {
				unsigned char j=0;
				*SymPtr=ptr_tab_txt[no_fold][no_txt];
				if ((*SymPtr)->flags.bits.archived) {
						j=1;
						EM_moveSymFromExtMem(SYMSTR((*SymPtr)->name),HS_NULL);  //on dsarchive
				}
#ifdef USE_KERNEL
				zipfile(*SymPtr,1);
//				ptr_tab_txt[no_fold][no_txt]=*SymPtr;
				tab_typ[no_fold][no_txt]=is_txt(*SymPtr);
#else
				if (is_txt(*SymPtr)==1) {  //on va zipper
						unsigned char  * data   = (unsigned char *)HeapDeref((*SymPtr)->handle);
						unsigned short longueur = *(unsigned short *)data+2;
						unsigned char * data2  = comp(data,&longueur);
						sprintf(name_var,"%s\\%s",folder[no_fold]->name,ptr_tab_txt[no_fold][no_txt]->name);
						*SymPtr=mk_var(name_var,data2,longueur,1);
						ptr_tab_txt[no_fold][no_txt]=*SymPtr;
						tab_typ[no_fold][no_txt]=2;
				} else {  //on va dzipper
						unsigned char  * data   = (unsigned char *)HeapDeref((*SymPtr)->handle);
						unsigned short longueur;
						unsigned char * data2  = decomp(data,&longueur);
						sprintf(name_var,"%s\\%s",folder[no_fold]->name,ptr_tab_txt[no_fold][no_txt]->name);
						*SymPtr=mk_var(name_var,data2,longueur,0);
						ptr_tab_txt[no_fold][no_txt]=*SymPtr;
						tab_typ[no_fold][no_txt]=1;
 				}
#endif
				if (j!=0) {
						EM_moveSymToExtMem(SYMSTR((*SymPtr)->name),HS_NULL);  //archivage
				}
 		} else if (K_F4) {
				aff_option();
 		} else if (K_F5) {
				//aff_aproposde();
				if ((*SymPtr=DerefSym(SymFindMain(SYMSTR(NOM_AIDE))))!=NULL) {  //recherche du texte de l'aide
						if (is_txt(*SymPtr)!=0) {
								memset(file_txt,0,sizeof(FILE_TXT));  //on efface tout
								file_txt->nom_fold=SymFindFirst(SYMSTR("main"),17)->name;
								goto fin;  //retourne le symptr du texte
						}
				}
				message(TXT_NO_AIDE);
				pause();
 	//	} else if (K_F5) {

		} else
				goto touche;  //une autre touche quelconque
	
		wait(vit_menu);  //petite pause: la calculatrice est vraiment trop rapide ...
		goto aff;

fin:

		for (j=0;j<nb_folder;j++) {
				free(ptr_tab_txt[j]);
				free(tab_typ[j]);
		}
		free(tab_nb_txt);
		free(ptr_tab_txt);
		free(tab_typ);
		free(folder);
		return 1;
}


//=======================================================================================================================
//=============================================== Allocation des mmoires ===============================================
//=======================================================================================================================

unsigned char alloc_screen(void) {

//allocation des mmoires pour les caractres + savescreen + vscreen
		if ((charset=malloc(10*256+8*256+6*256+2*256+LCD_SIZE+LCD_SIZE))==NULL)
				return 0;

		charwidth  = (unsigned short *)((void *)(charset+10*256+8*256+6*256));
		SetupCharSet();  //dessine les caractres

		return 1;
}

//=======================================================================================================================
//============================================== Allocations des tableaux ===============================================
//=======================================================================================================================

unsigned char alloc_tableaux(void) {
		unsigned char mem=0;

		file_txt->taille_var=20+(file_txt->longueur>>5);    //estimation (large) de 32 caractres par lignes  +  un minimum de 20 lignes

//allocation des tableaux
		if ((file_txt->ptr_liens=malloc(10*sizeof(unsigned short)))==NULL)
				return 0;
		memset(file_txt->ptr_liens,0,10*sizeof(unsigned short));

		if ((file_txt->ptr_txt=malloc(file_txt->taille_var*sizeof(unsigned short)))==NULL) {
				mem=3;
				goto mem;
		}
		memset(file_txt->ptr_txt,0,file_txt->taille_var*sizeof(unsigned short));
		
		if ((file_txt->format_ligne=malloc(file_txt->taille_var*sizeof(FORMAT)))==NULL) {
				mem=2;
				goto mem;
		}
		memset(file_txt->format_ligne,0,file_txt->taille_var*sizeof(FORMAT));
		
		if ((file_txt->pos_x_ligne=malloc(file_txt->taille_var*sizeof(unsigned char)))==NULL) {
				mem=1;
				goto mem;
		}
		memset(file_txt->pos_x_ligne,0,file_txt->taille_var*sizeof(unsigned char));

		if ((file_txt->haut_ligne=malloc(file_txt->taille_var*sizeof(unsigned char)))==NULL)
				goto mem;
		memset(file_txt->haut_ligne,0,file_txt->taille_var*sizeof(unsigned char));

		return 1;
		
mem:
		free(file_txt->ptr_liens);
		if (mem<3) {
				free(file_txt->ptr_txt);
				if (mem<2) {
						free(file_txt->format_ligne);
						if (mem<1)
								free(file_txt->pos_x_ligne);
				}
		}

		if (file_txt->typ==2) //c'tait un texte compress
				free(file_txt->texte-4);  //on libre ce que l'on a allou pour dcompresser
			
		return 0;

}

//=======================================================================================================================
//=============================================== Allocation des tampons ================================================
//=======================================================================================================================

unsigned char alloc_tampon(void) {

		if ((file_txt->tampon_haut=malloc(2*30*(file_txt->taille_tampon)))==NULL)
				return 0;
		
		file_txt->tampon_bas=file_txt->tampon_haut+30*(file_txt->taille_tampon);

		return 1;

}

//=======================================================================================================================
//===================================== Aquisition des donnes  aprtir de hibdata ======================================
//=======================================================================================================================

unsigned char ext_data(void) {
		SYM_ENTRY      * SymPtr = NULL;
		FILE           * file;
		unsigned short version;
		
		SymPtr=DerefSym(SymFind(SYMSTR("main\\hibdata")));
		if (SymPtr==NULL) {  //il faudra crer la variable
				vit_menu=VIT_MENU_DEF;
				vit_defil=VIT_DEFIL_DEF;
				auto_del_dbl=AUTO_DEL_DBL_DEF;
				auto_quit=AUTO_QUIT_DEF;
				confirm_del=CONFIRM_DEL_DEF;
				confirm_del_dbl=CONFIRM_DEL_DBL_DEF;
				max_hist=HIST_NB_MAX_DEF;
				historique->nb=0;
				favoris->nb=0;
				if ((favoris->tab_var=malloc(19*sizeof(unsigned char)))==NULL)
						return 0;
				if ((historique->tab_var=malloc((HIST_NB_MAX_DEF+1)*19*sizeof(unsigned char)))==NULL) {
						free(favoris->tab_var);
						return 0;
				}				
		} else {
				file=fopen("main\\hibdata","rb");
				fread((void *)(&version),2,sizeof(char),file);
				fread((void *)(&vit_menu),1,sizeof(char),file);
				fread((void *)(&vit_defil),1,sizeof(char),file);
				if (version<106) {
						auto_del_dbl=AUTO_DEL_DBL_DEF;
						auto_quit=AUTO_QUIT_DEF;
						confirm_del=CONFIRM_DEL_DEF;
						confirm_del_dbl=CONFIRM_DEL_DBL_DEF;
				} else {
						fread((void *)(&auto_del_dbl),1,sizeof(char),file);
						fread((void *)(&auto_quit),1,sizeof(char),file);
						fread((void *)(&confirm_del),1,sizeof(char),file);
						fread((void *)(&confirm_del_dbl),1,sizeof(char),file);
				}
				fread((void *)(&max_hist),1,sizeof(char),file);
				fread((void *)(&historique->nb),1,sizeof(char),file);
				fread((void *)(&favoris->nb),1,sizeof(char),file);
				if ((favoris->tab_var=malloc((favoris->nb+1)*19*sizeof(unsigned char)))==NULL)
						return 0;
				if ((historique->tab_var=malloc((max_hist+1)*19*sizeof(unsigned char)))==NULL) {
						free(favoris->tab_var);
						return 0;
				}

				memcpy(favoris->tab_var,file->fpos,favoris->nb*19*sizeof(unsigned char));
				memcpy(historique->tab_var,file->fpos+favoris->nb*19*sizeof(unsigned char),historique->nb*19*sizeof(unsigned char));

				fclose(file);

		}
		
		return 1;
		
}

//=======================================================================================================================
//=================================== Sauvegarde des dones dans une varable externe ====================================
//=======================================================================================================================

void save_data(void) {
		SYM_ENTRY      * SymPtr = NULL;
		FILE           * file;
		HSym           hsym;
		unsigned short j;

		SymPtr=DerefSym(hsym=SymFind(SYMSTR("main\\hibdata")));
		if (SymPtr->flags.bits.archived)
				EM_moveSymFromExtMem(NULL,hsym);  //on dsarchive
		file=fopen("main\\hibdata","wb");
		fputc(VERSION/256,file);
		fputc(VERSION%256,file);
		fputc(vit_menu,file);
		fputc(vit_defil,file);
		fputc(auto_del_dbl,file);
		fputc(auto_quit,file);
		fputc(confirm_del,file);
		fputc(confirm_del_dbl,file);
		fputc(max_hist,file);
		fputc(historique->nb,file);
		fputc(favoris->nb,file);

		for (j=0;j<19*((unsigned short)favoris->nb);j++)
				fputc(favoris->tab_var[j],file);

		for (j=0;j<19*((unsigned short)max_hist);j++)
				fputc(historique->tab_var[j],file);

		fputc(0,file);
		fputs("SAV",file);
		fputc(0,file);
		fputc(OTH_TAG,file);
		fclose(file);

		EM_moveSymToExtMem(NULL,SymFind(SYMSTR("main\\hibdata")));  //archivage

		free(favoris->tab_var);
		free(historique->tab_var);
}

//=======================================================================================================================
//==================================================== Main Function ====================================================
//=======================================================================================================================

void _main(void) {

		void                * savescreen  = NULL;  //sauve l'cran home
		FILE_TXT            file;             //texte   afficher
		file_txt=&file;

		TAB_TXT hist;
		TAB_TXT fav;
		historique=&hist;
		favoris=&fav;
		
		short         i            = 0;  //variable de boucle
		short         j            = 0;
		unsigned char name_var[20];
		unsigned char chartmp[20];
		unsigned char *texte;
		ESI           argptr;
		unsigned char argtype;
		SYM_ENTRY     * SymPtr     = NULL;
		
		short no_ptr;        //no de case d'un dbut de ligne
		short ptr_haut_max;  //dernier ptr_haut affichable
		short ptr_bas;       //no dans ptr_txt texte de la dernire ligne (en fait dans le tampon)
		short ptr_haut;      //...de la premire

		short pos_bas  = 0;  //taille en pxl du texte en "tampon" en bas
		short pos_haut = 0;  //  ... en haut

//utilisation de f_rowread
		INT_HANDLER save_int_1;
	
		save_int_1 = GetIntVec(AUTO_INT_1);
		SetIntVec(AUTO_INT_1, DUMMY_HANDLER);

//allocation des mmoires graphiques
		if (alloc_screen()==0) {
				message_fin=TXT_ERR_MEM("1");
				goto fin;
		}

//sauvegarde de l'cran
		savescreen=(void *)(charset+10*256+8*256+6*256+2*256);
		vscreen=(void *)(savescreen+LCD_SIZE);
		memcpy(savescreen,LCD_MEM,LCD_SIZE);

//initialisation
		memset(file_txt,0,sizeof(FILE_TXT));
		if ((ext_data())==0) {
				message_fin=TXT_ERR_MEM("2");
				goto fin_screen;
		}

//FontSetSys(F_4x6);
		
//recherche du texte qu'on veut afficher
		InitArgPtr(argptr);//=top_estack;
		argtype=GetArgType(argptr);

		switch (argtype) {
				case STR_TAG:  //on a rentr le nom d'un texte
						if (strlen(GetStrnArg(argptr))>16)
								goto erreur;
						InitArgPtr(argptr);
						strcpy(name_var,GetStrnArg(argptr));
						if ((SymPtr=DerefSym(SymFind(SYMSTR(name_var))))==NULL) {
								message_fin=TXT_ERR_INTR;
								goto fin_screen;
						}
						if (is_txt(SymPtr)==0) {
								message_fin=TXT_ERR_ENTRE_TXT;
								goto fin_screen;
						}
						InitArgPtr(argptr);
						sym_fold(GetStrnArg(argptr));
						ptr_haut=0;
						goto init;
				case END_TAG:  //rien en argument : affichge du menu
						break;
				default:
erreur:
						message_fin=TXT_ERR_TAPEZ;
						goto fin_screen;
		}

choix_txt:
		ptr_haut=0;
		if (menu(&ptr_haut,&SymPtr)==0) {
				message_fin=TXT_ERR_MEM("3");
				goto fin_screen;
		}
		if (SymPtr==NULL) //on veut quitter
				goto fin_screen;
//pour l'affichage de la premire page

init:
		if (sym_file(SymPtr)==0) { //initialise les variables de file_txt
				message_fin=TXT_ERR_MEM("4");
				goto fin_screen;
		}
		file_txt->nb_liens=0;
		file_txt->nb_marque=0;
		file_txt->taille_tampon=0;
		clrscr();		//on nettoie l'cran
		message(TXT_CHARG);
		if (alloc_tableaux()==0) {
				message(TXT_MQ_MEM("1"));
				pause();
				goto choix_txt;
		}

//initialisation des variables
		memset(&((file_txt->format_ligne)[0]),0,sizeof(FORMAT));
		(file_txt->ptr_txt)[0]=1;  //on commence au caractre 1
//		(format_ligne[0]).taille1=0; //taille 2 par dfaut
		((file_txt->format_ligne)[0]).taille2=1;

//etude de tout le texte
		if ((ptr_haut_max=etude_txt())==0) {
		 		free_file();
				goto choix_txt;
		}
		ptr_haut_max--;
		if ((alloc_tampon())==0) {
		 		free_file();
				goto choix_txt;
		}

//on met le texte dans l'historique
		if (historique->nb!=max_hist)
				historique->nb++;
		for (j=0;j<historique->nb-1;j++)  //on dplace tout
				memcpy(&(historique->tab_var[19*(historique->nb-j-1)]),&(historique->tab_var[19*(historique->nb-j-2)]),19);
		strcpy(&(historique->tab_var[0]),file_txt->nom_fold);
		strcpy(&(historique->tab_var[9]),file_txt->nom_var);
		historique->tab_var[18]=0;
		if (ptr_haut<0) {  //utilisation d'un lien hypertexte
				if (file_txt->nb_marque>(-ptr_haut)) {
						historique->tab_var[18]=-(ptr_haut++);
						ptr_haut=file_txt->marque_page[(-ptr_haut)];
				} else {
						ptr_haut=0;
				}
		}
		if (auto_del_dbl) //on efface les doublons
				del_double();

//affichage de la page
		if (ptr_haut<=ptr_haut_max) {
				ptr_bas=aff_page(ptr_haut,&pos_bas,&pos_haut,LCD_MEM);
		} else {
				last_page(ptr_haut_max,&ptr_haut,&ptr_bas,&pos_haut,&pos_bas);
		}

//boucle qui attend une touche
touche:
		if (K_BAS) {  //[BAS] dplacement vers la fin du texte sauf si pas de tampon
				if (K_DIAM) {//[diamand]
						last_page(ptr_haut_max,&ptr_haut,&ptr_bas,&pos_haut,&pos_bas);
				} else if (K_2ND) {//2nd
						if (ptr_bas>ptr_haut_max) {//on descend tout en bas
								last_page(ptr_haut_max,&ptr_haut,&ptr_bas,&pos_haut,&pos_bas);
						} else {  //on descend d'un cran : la ligne du bas devient la ligne du haut
								ptr_bas=aff_page((ptr_haut=ptr_bas),&pos_bas,&pos_haut,LCD_MEM); //affichage dans l'cran
						}
						wait(vit_menu);
				} else { //on fait dfiler d'un pixel
						pos_bas++;
						if (pos_bas>=file_txt->haut_ligne[ptr_bas]) {
								if (file_txt->texte[file_txt->ptr_txt[ptr_bas+1]]==0) {
										pos_bas--;
										goto touche;
								}										
								pos_bas=0;
								memset(file_txt->tampon_bas,0,file_txt->taille_tampon*30);
								aff_ligne(++ptr_bas,file_txt->tampon_bas,0);
						}
						pos_haut++;
						if (pos_haut>=file_txt->haut_ligne[ptr_haut]) {
								pos_haut=0;
								memset(file_txt->tampon_haut,0,file_txt->taille_tampon*30);
								aff_ligne(++ptr_haut,file_txt->tampon_haut,0);
						}
						defile_haut(LCD_MEM,pos_bas);
				}
		} else if (K_HAUT) {  //[HAUT] dplacement vers le dbut du texte sauf si pas de tampon
				if (K_DIAM) {//diamand
						ptr_bas=aff_page((ptr_haut=0),&pos_bas,&pos_haut,LCD_MEM);  //afichage de la premire page
				} else if (K_2ND) {//2nd
						j=0;
						while ((unsigned short)j<LCD_HEIGHT && ptr_haut>=0) {  //on remonte d'un taille d'cran
								j+=file_txt->haut_ligne[--ptr_haut];
						}
						ptr_bas=aff_page(++ptr_haut,&pos_bas,&pos_haut,LCD_MEM); //affichage dans l'cran
						wait(vit_menu);
				} else {  //dfilement d'un pixel
						pos_haut--;
						if (pos_haut<0) {
								if (file_txt->ptr_txt[ptr_haut]==1) {
										pos_haut++;
										goto touche;
								}
								pos_haut=file_txt->haut_ligne[--ptr_haut]-1;
								memset(file_txt->tampon_haut,0,file_txt->taille_tampon*30);
								aff_ligne(ptr_haut,file_txt->tampon_haut,0);
						}
						pos_bas--;
						if (pos_bas<0) {
								pos_bas=file_txt->haut_ligne[--ptr_bas]-1;
								memset(file_txt->tampon_bas,0,file_txt->taille_tampon*30);
								aff_ligne(ptr_bas,file_txt->tampon_bas,0);
						}
						defile_bas(LCD_MEM,pos_haut);
				}
		} else if (K_HOME) {//[HOME]
				off();
		} else if (K_APPS) {//[APPS] : marque pages
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				if ((no_ptr=aff_marque_page())!=0) {  //on a choisi un marque page
						no_ptr--;
marq_page:
						if (no_ptr>ptr_haut_max) {  //le marque page est dans la dernire page 
								last_page(ptr_haut_max,&ptr_haut,&ptr_bas,&pos_haut,&pos_bas);
						} else {  //affichage de la page commencant par le marque page
								ptr_bas=aff_page((ptr_haut=no_ptr),&pos_bas,&pos_haut,LCD_MEM); //affichage dans l'cran
						}
				}	else
						memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_ESC) {  //[ESC] : on quitte
				free_file();
				free(file_txt->tampon_haut);
				if (argtype==STR_TAG && auto_quit)
 						goto fin_screen;  //on retourne dans l'cran home
				goto choix_txt;  //on revient au choix de texte
 		} else if (K_PLUS && K_DIAM) {
				OSContrastUp();
				wait(vit_menu);
 		} else if (K_MOINS && K_DIAM) {
 				OSContrastDn(); 			
				wait(vit_menu);
 		} else if (K_CATALOG) {//lien
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				j=(LCD_HEIGHT>>1)-8+3;  //hauteur d'criture des messages
				if (file_txt->nb_liens==0) {
						message(TXT_NO_LIEN);
						pause();
				} else {
						no_ptr=choix_lien();
						wait(vit_menu);
						if (no_ptr>file_txt->nb_liens) {
								message(TXT_BAD_LIEN);
								pause();
						} else if (no_ptr!=0) {
								no_ptr=file_txt->ptr_liens[no_ptr-1];
								i=0;
								texte=file_txt->texte;
								j=0;
								while (texte[no_ptr]!='#' && texte[no_ptr]!=13 && texte[no_ptr]!=0 && i<19) { //on recopie tout le lien
										if (texte[no_ptr]=='\\')
												j=1;  //dtecte si un nom de repertoire est spcifi
										name_var[i++]=texte[no_ptr++];
								}
								name_var[i]=0;
								if (j==0) {//pas de repertoire spcifi
										FolderGetCur(chartmp); //on recherche le rpertoire actif
										sprintf(name_var,"%s\\%s",name_var,chartmp);
								}
								i=0;
								if (texte[no_ptr++]=='#') {  //recherche d'u numro du marque page
										while (texte[no_ptr]>='0' && texte[no_ptr]<='9' && i<1000) {
												i=10*i+(texte[no_ptr]-'0');
												no_ptr++;
										}
										if (i>file_txt->nb_marque)
												i=0;
								}
chg_txt:
								sprintf(chartmp,"%s\\%s",file_txt->nom_fold,file_txt->nom_var);
								if (strcmp(name_var,chartmp)==0) {//on est dans le text recherch
										no_ptr=file_txt->marque_page[i];
										goto marq_page;
								}
								if ((SymPtr=DerefSym(SymFind(SYMSTR(name_var))))!=NULL) {
										if (is_txt(SymPtr)!=0) {
												free_file();
												free(file_txt->tampon_haut);
												sym_fold(name_var);
												ptr_haut=(-i);
												goto init;
										}
								}
								message(TXT_NO_REC);
								pause();
						}
				}
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_F1) {  //favoris
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				sprintf(name_var,"%s\\%s",file_txt->nom_fold,file_txt->nom_var);
				if ((j=choix(favoris, TXT_FAV, name_var,1))!=0) {
						j--;
						sprintf(name_var,"%s\\%s",&(favoris->tab_var[19*j]),&(favoris->tab_var[19*j+9]));
						i=favoris->tab_var[19*j+18];
						goto chg_txt;
				}
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_F2) {  //historique
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				if ((j=choix(historique, TXT_TIT_HIST,NULL,2))!=0) {
						j--;
						sprintf(name_var,"%s\\%s",&(historique->tab_var[19*j]),&(historique->tab_var[19*j+9]));
						i=historique->tab_var[19*j+18];
						goto chg_txt;
				}
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_F3) {
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				aff_option();
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_F4) {
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				if ((SymPtr=DerefSym(SymFindMain(SYMSTR(NOM_AIDE))))!=NULL) {
						if (is_txt(SymPtr)!=0) {
								free_file();
								free(file_txt->tampon_haut);
								strcpy(file_txt->nom_fold,"main");
								ptr_haut=0;
								goto init;
						}
				}
				message(TXT_NO_AIDE);
				pause();
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
		} else if (K_F5) {
				memcpy(vscreen,LCD_MEM,LCD_SIZE);  //sauvegarde de l'cran
				aff_aproposde();
				memcpy(LCD_MEM,vscreen,LCD_SIZE);  //on revient  l'cran prcdent
 		} else if (K_0) {
 				if (file_txt->nb_marque>0) {
 						no_ptr=file_txt->marque_page[0];
 						goto marq_page;
 				}
 		} else if (K_1) {
 				if (file_txt->nb_marque>1) {
 						no_ptr=file_txt->marque_page[1];
 						goto marq_page;
 				}
 		} else if (K_2) {
 				if (file_txt->nb_marque>2) {
 						no_ptr=file_txt->marque_page[2];
 						goto marq_page;
 				}
 		} else if (K_3) {
 				if (file_txt->nb_marque>3) {
 						no_ptr=file_txt->marque_page[3];
 						goto marq_page;
 				}
 		} else if (K_4) {
 				if (file_txt->nb_marque>4) {
 						no_ptr=file_txt->marque_page[4];
 						goto marq_page;
 				}
 		} else if (K_5) {
 				if (file_txt->nb_marque>5) {
 						no_ptr=file_txt->marque_page[5];
 						goto marq_page;
 				}
 		} else if (K_6) {
 				if (file_txt->nb_marque>6) {
 						no_ptr=file_txt->marque_page[6];
 						goto marq_page;
 				}
 		} else if (K_7) {
 				if (file_txt->nb_marque>7) {
 						no_ptr=file_txt->marque_page[7];
 						goto marq_page;
 				}
 		} else if (K_8) {
 				if (file_txt->nb_marque>8) {
 						no_ptr=file_txt->marque_page[8];
 						goto marq_page;
 				}
 		} else if (K_9) {
 				if (file_txt->nb_marque>9) {
 						no_ptr=file_txt->marque_page[9];
 						goto marq_page;
 				}
 		}
		goto touche;  //on reboucle

fin_screen:
		memcpy(LCD_MEM,savescreen,LCD_SIZE);  //restauration de l'cran home
		free(charset);
		save_data();
fin:
		SetIntVec(AUTO_INT_1, save_int_1);
		ST_helpMsg(message_fin);
}
