// C Header File
// Created 17/06/2002; 22:04:33

unsigned char *  charset   = NULL;  //adresse des images des caractres (cf ci-dessous)
unsigned short * charwidth = NULL;		//longueur des caractres de petite police

//valeurs de font et font2 pour FastChar
#define POLICE_1 6,18
#define POLICE_2 8,10
#define POLICE_3 10,0

//=======================================================================================================================
//======================== Cration des sprites de tous les caractres pour utiliser une propre =========================
//======================== routine d'affichage plus rapide que DrawChar (merci TICT!)           =========================
//=======================================================================================================================

static inline void SetupCharSet(void) {
		unsigned short i;

		// Little font
		FontSetSys(F_4x6);
		memset(charset,0,6*256+8*256+10*256);
		PortSet(charset+10*256+8*256,7,6*256-1);

		for (i=0;i<256;i++) {
				charwidth[i] = FontCharWidth(i);
				DrawChar(0,i*6+(i==103),i,A_REPLACE);  //on baisse le g
		}

		// Medium font
		FontSetSys(F_6x8);
		PortSet(charset+10*256,7,8*256-1);

		for (i=0;i<256;i++)
				DrawChar(0,i<<3,i,A_REPLACE);

    // Big font
		FontSetSys(F_8x10);
		PortSet(charset,7,10*256-1);

		for (i=0;i<256;i++)
				DrawChar(0,i*10,i,A_REPLACE);

		FontSetSys(F_6x8);
		PortRestore();
}

//=======================================================================================================================
//========================================= Affiche un caractre (merci TICT!) ==========================================
//=======================================================================================================================

void FastChar(short x,short y,unsigned char c,void *plane,short font,short font2) {
		unsigned char  * sprite = &charset[font2*256+((short)c)*font];
		long           addr     = ((long)plane)+(y<<5)-(y<<1)+((x>>3)&0xfffe);
		unsigned short cnt      = 25-(x&15);

            // unrolled loop for more speed ...
		*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
		*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
		*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
		*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
		*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
		*(long*)addr|=(long)(*sprite++)<<cnt;
		if (font!=6) {
				addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt;
				if (font==10) {
						addr+=30;
						*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
						*(long*)addr|=(long)(*sprite++)<<cnt;
				}
		}

}

//=======================================================================================================================
//=================================== Affiche une chaine de caractres (merci TICT!) ====================================
//=======================================================================================================================

void FastStr(short x,short y,const unsigned char *str,void *plane, short font, short font2) {
		unsigned char  * sprite;
		long           addr;
    long           addr_const = ((long)plane)+(y<<5)-(y<<1);
		unsigned short cnt;

		while (*str) {
				sprite=&charset[font2*256+((short)(*str))*font];
				addr = addr_const+((x>>3)&0xfffe);
				cnt  = 25-(x&15);
            // unrolled loop for more speed ...
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr|=(long)(*sprite++)<<cnt;
				if (font!=6) {
						addr+=30;
						*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
						*(long*)addr|=(long)(*sprite++)<<cnt;
						if (font==10) {
								addr+=30;
								*(long*)addr|=(long)(*sprite++)<<cnt; addr+=30;
								*(long*)addr|=(long)(*sprite++)<<cnt;
								x+=8;
						} else
								x+=6;
				} else
						x+=charwidth[(short)(*str)];
				str++;
		}

}
//=======================================================================================================================
//========================= Affiche une ligne horizontale sur tout l'cran (merci TICT!) ================================
//=======================================================================================================================
void FastestDrawHLine(unsigned char* plane,short y);
		asm("xdef FastestDrawHLine\n"
				"FastestDrawHLine:\n"
				"  pea    (%a0)\n"
				"  move.l %d0,-(%sp)\n"
				"  move.l %d1,-(%sp)\n"
				"  move.l 16(%sp),%a0\n"
				"  moveq  #0,%d0\n"
				"  move.w 20(%sp),%d0\n"
				"  lsl.w  #1,%d0\n"
				"  move.w %d0,%d1\n"
				"  lsl.w  #4,%d0\n"
				"  sub.w  %d1,%d0\n"
				"  adda.l %d0,%a0\n"
				"  moveq  #-1,%d1\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.l %d1,(%a0)+\n"
				"  move.w %d1,(%a0)\n"
				"  move.l (%sp)+,%d1\n"
				"  move.l (%sp)+,%d0\n"
				"  move.l (%sp)+,%a0\n"
				"  rts");

//=======================================================================================================================
//================================================= Affiche d'un pixel (x,y) ============================================
//=======================================================================================================================

void aff_pix(unsigned char x, unsigned char y, void *ecran) {
		unsigned char * p;

		p=(ecran+(y<<5)-(y<<1)+(x>>3));
		*p|=((0x80)>>(x&0x07));
}

//=======================================================================================================================
//================================= Affiche une ligne verticale entre y1 et y2 ==========================================
//=======================================================================================================================

void DrawVertLine(unsigned char x, unsigned char y1,unsigned char y2,void *ecran) {
		unsigned char * p;
		unsigned char pix       = ((0x80)>>(x&0x07));
		void          * pos_ecr = ecran+(x>>3);
		
		for (;y1<y2;y1++) {
				p=(y1<<5)-(y1<<1)+pos_ecr;
				*p|=pix;
		}
}

//=======================================================================================================================
//======================================= Utilisation de la fonction swap de l'asm ======================================
//=======================================================================================================================

#define ASM_SWAP(val) ({\
		register unsigned long tmp = val;\
		asm volatile ("swap %0" : "=d" (tmp) : "0" (tmp));\
		tmp;})

//=======================================================================================================================
//================== Affiche une ligne horizontale de (x1,y)  (x2,y) ( partir d'une routine de TICT!) =================
//=======================================================================================================================

void horiz_ligne(unsigned char x1, unsigned char x2, unsigned char y, void *ecran) {  //  0 <= x2-x1 < 16
		unsigned long        * p;
		const unsigned short nb_pix[] = {0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xff00,
																		 0xff80, 0xffc0, 0xffe0, 0xfff0, 0xfff8, 0xfffc, 0xfffe, 0xffff};

		p=(ecran+(y<<5)-(y<<1)+((x1>>3)&0xfffe));
		*p|=((ASM_SWAP(nb_pix[x2-x1]))>>(x1&0x0f));

}
//=======================================================================================================================
//================== Efface une ligne horizontale de (x1,y)  (x2,y) ( partir d'une routine de TICT!) ==================
//=======================================================================================================================

void del_ligne(unsigned char x1, unsigned char x2, unsigned char y, void *ecran) {  //  0 <= x2-x1 < 8
		unsigned long        * p;
		const unsigned short nb_pix[] = {0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xff00};
		
		p=(ecran+(y<<5)-(y<<1)+((x1>>3)&0xfffe));
		*p&=(~((ASM_SWAP(nb_pix[x2-x1]))>>(x1&0x0f)));

}

//=======================================================================================================================
//=================== Inverse les couleurs du cadre (x1,y1)  (x2,y2) ( partir d'une routine de TICT!) =================
//=======================================================================================================================

void inverse(unsigned char x1, unsigned char x2, unsigned char y1, unsigned char y2, void *ecran) {  //  0 <= x2-x1 < 8  et  y1<y2
		unsigned long        * p;
		const unsigned short nb_pix[] = {0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xff00};

		for (;y1<=y2;y1++) {
				p=(ecran+(y1<<5)-(y1<<1)+((x1>>3)&0xfffe));
				*p^=((ASM_SWAP(nb_pix[x2-x1]))>>(x1&0x0f));
		}
}
