// C Header File
// Created 17/06/2002; 17:43:47



/*
;----------------------------------------------------------------------------
; check_cmem()
;
; Function: Checks if there are enough memory free for
;           compression ( 2560 B needed ) **AND** for evaluating 
;	    compressed size ( 1140 needed )
;
; Input:    A0   = Pointer to data which will be compressed
;	    D0.W = Length of data which will be compressed
;
; Output:   D0.W = 0 if NOT enough memory
;             NO OTHER REGISTERS DESTROYED
;
;----------------------------------------------------------------------------
ziplib::check_cmem	equ	ziplib@0000
*/
/*unsigned short check_cmem(void *ptr_data,unsigned long len) {
		unsigned short ok=0; 
		asm ("move.l %0,%%a0" :: "g"(ptr_data));
		asm ("move.w %0,%%d0" :: "g"(len));
		asm ("jsr ziplib__0000");
		asm ("move.w %%d0,%0" :: "g"(ok));
		return ok;
}*/
/*
;----------------------------------------------------------------------------
; check_emem()
;
; Function: Checks if there are enough memory free for
;           extraction (same command as Hufflib's : check_mem)
;
; Input:    A0   = Pointer to compressed data
;
; Output:   D0.W = 0 if NOT enough memory
;	    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::check_emem	equ	ziplib@0001
*/
/*unsigned short check_emem(void *ptr_data) {
		unsigned short ok=0; 
		asm ("move.l %0,%%a0" :: "g"(ptr_data));
		asm ("jsr ziplib__0001");
		asm ("move.w %%d0,%0" :: "g"(ok));
		return ok;
}*/
/*
;----------------------------------------------------------------------------
; eval_cmem()
;
; Function: Evaluates the mem size of the compressed file.
;
; Input:    A0   = Pointer to datas which will be compressed 
;	    D0.L = Length of datas which will be compressed
;
; Output:   D0.W = mem size of datas when they will be compressed
;		    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::eval_cmem	equ	ziplib@0002
*/
/*unsigned short eval_cmem(void *ptr_data, unsigned long len) {
		unsigned short memsize=0;
		asm ("move.l %0,%%a0" :: "g"(ptr_data));
		asm ("move.l %0,%%d0" :: "g"(len));
		asm ("jsr ziplib__0002");
		asm ("move.w %%d0,%0" :: "g"(memsize));
		return memsize;
}*/

/*
;----------------------------------------------------------------------------
; eval_emem()
;
; Function: Evaluates the mem size of the extracted file.
;		(works only with single file archive)
;
; Input:    A0   = Pointer to datas which will be uncompressed 
;
; Output:   D0.W = mem size of datas when they will be uncompressed
;		    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::eval_emem	equ	ziplib@0003
*/
/*unsigned short eval_emem(void *ptr_data) {
		unsigned short memsize=0;
		asm ("move.l %0,%%a0" :: "g"(ptr_data));
		asm ("jsr ziplib__0002");
		asm ("move.w %%d0,%0" :: "g"(memsize));
		return memsize;
}*/
/*
;----------------------------------------------------------------------------
; compress()
;
; Function: compress data
;
; Input:    A0   = Pointer to uncompressed data
;           A1   = Pointer to where the compressed data should be stored
;	    D0.W = Length of datas which will be compressed
;----------------------------------------------------------------------------
ziplib::compress	equ	ziplib@0004
*/
/*
void compress(void *scr, void *dest, unsigned long len) {
		asm ("move.l %0,%%a0" :: "g"(scr));
		asm ("move.l %0,%%a1" :: "g"(dest));
		asm ("move.w %0,%%d0" :: "g"(len));
		asm ("jsr ziplib__0004");
}
*/
/*#define compress(scr,dest,len) \
	({void *__scr=(scr), *__dest=(dest); \
		unsigned long __len=(len);\
		asm ("move.l %0,%%a0" :: "g"(__scr)); \
		asm ("move.l %0,%%a1" :: "g"(__dest)); \
		asm ("move.w %0,%%d0" :: "g"(__len)); \
		asm ("jsr ziplib__0004"); })
*/
/*
;----------------------------------------------------------------------------
; extract()
;
; Function: Extracts data ( in fact same routine as hufflib's one )
;
; Input:    A0   = Pointer to compressed data
;           A1   = Pointer to where the uncompressed data should be stored
;----------------------------------------------------------------------------
ziplib::extract	equ	ziplib@0005
*/
/*void extract(void *scr, void *dest) {
		asm ("move.l %0,%%a0" :: "g"(scr));
		asm ("move.l %0,%%a1" :: "g"(dest));
		asm ("jsr ziplib__0005");
}*/
#define extract(scr,dest) \
	({void *__scr=(scr), *__dest=(dest); \
		asm ("move.l %0,%%a0" :: "g"(__scr)); \
		asm ("move.l %0,%%a1" :: "g"(__dest)); \
		asm ("jsr ziplib__0005"); })

/*
;----------------------------------------------------------------------------
; zipfile()
;
; Function: Compress or Extract a file
;
; Input:    A0   = Pointer to file in the VAT
;	    D0.B = 0 disable commentary 
;		   1 semi-commentary (error displayed)
;		   else enable commentary (Windows, Confirmations,...)
;
; Output:        D0.B = 0 no error 				
;		   	1 can't manipulate because file is archived
;         	   	2 compressed file bigger than original
;		   	3 not enough memory
;			4 Program running
;		    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::zipfile	equ	ziplib@0006
*/
unsigned char zipfile(SYM_ENTRY * ptr, unsigned char comment) {
		asm ("move.l %0,%%a0" :: "g"(ptr));
		asm ("move.b %0,%%d0" :: "g"(comment));
		asm ("jsr ziplib__0006");
		asm ("move.b %0,%%d0" :: "g"(comment));
		return comment;
}
/*
;----------------------------------------------------------------------------
; iscomp()
;
; Function: Test if a file is compressed
;
; Input:    A0   = Pointer to file in the VAT
;
; Output:        D0.W = 0 compressed 				
;		   	1 uncompressed
;
;		    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::iscomp		equ	ziplib@000B
*/
unsigned char iscomp(void *ptr_file) {
		unsigned char ok=0;
		asm ("move.l %0,%%a0" :: "g"(ptr_file));
		asm ("jsr ziplib__000B");
		asm ("move.w %%d0,%0" :: "g"(ok));
		return ok;
}
/*
;----------------------------------------------------------------------------
; tempfile()
;
; Function: Extract a compressed file to a temporary handle
;
; Input:    A0   = Pointer to file in the VAT
;	    D0.B = 0 disable commentary 
;		   1 semi-commentary (error displayed)
;		   else enable commentary (Windows, Confirmations,...)
;
; Output:    	 D0.B = 0 no error 				
;		   	1 can't manipulate because file is archived, locked or hidden
;		   	3 not enough memory
;			5 File is not a compressed file
;		 D1.W = handle of the temporary file
;		    NO OTHER REGISTERS DESTROYED
;----------------------------------------------------------------------------
ziplib::tempfile	equ	ziplib@0007
*/
unsigned char * tempfile(void *ptr_file, unsigned char *comment) {
		unsigned char * temp=NULL;
		asm ("move.l %0,%%a0" :: "g"(ptr_file));
		asm ("move.b %0,%%d0" :: "g"(*comment));
		asm ("jsr ziplib__0007");
		asm ("move.b %%d0,%0" :: "g"(*comment));
		asm ("move.w %%d1,%0" :: "g"(temp));
		return temp;
}

/*
;----------------------------------------------------------------------------
; extract_string()
;
; Function: Extracts a string from huffman compressed data
;
; Input:    A0   = Pointer to huffman compressed data
;           A1   = Pointer to where the string should be stored
;           D3.W = File number to extract (not necessary if not multifile)
;           D4.W = String number. First string = number 0
;----------------------------------------------------------------------------
ziplib::extract_string	equ	ziplib@0008
*/

/*
;----------------------------------------------------------------------------
; write_string()
;
; Function: Writes a compressed string with the current font. The string
;           should not be longer than 80 characters.
;
; Input:    A0   = Pointer to huffman compressed data
;           D0.W = x location
;           D1.W = y location
;           D3.W = File number to extract (not necessary if not multifile)
;           D4.W = String number. First string = number 0
;----------------------------------------------------------------------------
ziplib::write_string	equ	ziplib@0009
*/

/*
;----------------------------------------------------------------------------
; write_string_inv()
;
; Function: Writes a compressed string with the current font (inverted color)
;           The string should not be longer than 80 characters.
;
; Input:    A0   = Pointer to huffman compressed data
;           D0.W = x location
;           D1.W = y location
;           D3.W = File number to extract (not necessary if not multifile)
;           D4.W = String number. First string = number 0
;----------------------------------------------------------------------------
ziplib::write_string_inv	equ	ziplib@000A
*/
/*

SYM_ENTRY *get_entry(char *str) {
		char *nom = mk_nam(str) ;
		SYM_ENTRY *entry = get_temp_entry(nom) ;
	
		if (entry != NULL) //la var existe dans le rep temp
				return entry ;
		return SymFindPtr(nom, 0) ;  //on la cherche autre part
}
//=======================================================================================================================

unsigned short var_len(char *var)
{
	return (2+*(unsigned short*)var) ;
}
//=======================================================================================================================


char *get_ptr(SYM_ENTRY *entry) {
		if (entry == NULL || entry->handle == H_NULL)
				return NULL ;
		return (char*)HeapDeref(entry->handle) ;
}
//=======================================================================================================================

SYM_ENTRY *get_temp_entry(char *nom) {  //retourne l'entre sym de nom si il existe dans le repertoire temporaire, null sinon
		SYM_ENTRY *entry = DerefSym(FindSymInFolder(nom, TempFolderName(Temp))) ;
	
		while (*(--nom) != 0 && *nom != 92) // '\'=92
				;
		return ( (entry != NULL && *nom != 92) ? entry : NULL) ;
}
//=======================================================================================================================

char *mk_nam(char *str) {
		static char name[19] = {0} ;
		short len = strlen(str) ;
	
		if (len > 17)
				return NULL ;
	
		return strcpy(name+1, str)+len ;
}
//=======================================================================================================================
short check(char *str) {
		SYM_ENTRY *entry = get_entry(str) ;
	
		if (entry != NULL && entry->flags.bits.archived != 0)	{
				return EM_moveSymFromExtMem(mk_nam(str), HS_NULL) ;
		}
		return 1 ;
}
//=======================================================================================================================

char *mk_ptr(char *str, unsigned short taille) {
		char *nom = mk_nam(str) ;
		SYM_ENTRY *entry = get_temp_entry(nom) ;

		if (check(str) == 0)  //dsarchive, si possible
				return NULL ;

		entry = DerefSym(entry != NULL ? AddSymToFolder(nom, TempFolderName(Temp)) : SymAdd(nom)) ;  //recre la var
		if (entry == NULL)
				return NULL ;

		nom = (char*)HeapDeref(entry->handle = HeapAlloc(taille)) ;
		if (entry->handle == H_NULL)
				return NULL ;

		*(unsigned short*)nom = taille-2 ;

		return (nom+2) ;
}
//=======================================================================================================================

char *mk_perso_ptr(char *str, char *extension, unsigned short taille) {
		unsigned char *var = mk_ptr(str, taille) ;

		if (var == NULL)
				return NULL ;

		*(var+taille-strlen(extension)-5) = 0 ;
		strcpy(var+taille-strlen(extension)-4, extension) ;
		*(var+taille-3) = OTH_TAG ;

		return var ;
}*/
