// C Header File
// Created 19/07/2002; 14:30:12

//=======================================================================================================================
//========================================= Structure de l'arbre de compression =========================================
//=======================================================================================================================

struct hArbre {
		struct hArbre *gauche ;
		struct hArbre *droite ;
		short valeur ;
		short priorite ;
} ;

//=======================================================================================================================
//======================================= (Re)cre la variable dans la table VAT ========================================
//=======================================================================================================================

SYM_ENTRY * mk_var(const unsigned char * nom_var, unsigned char * data2, unsigned short longueur, unsigned char comp) {
		SYM_ENTRY * SymPtr;
		unsigned char arch=0;
		unsigned char * data;
		
		SymPtr=DerefSym(SymFind(SYMSTR(nom_var)));
		if (SymPtr->flags.bits.archived) {
				EM_moveSymFromExtMem(SYMSTR(nom_var),HS_NULL);
				arch=1;
		}
		SymPtr=DerefSym(SymAdd(SYMSTR(nom_var)));
		if ((data = (unsigned char *)HeapDeref(SymPtr->handle = HeapAlloc(longueur+2+7*comp)))==NULL)
				return NULL;
		*(unsigned short*)data = longueur+7*comp;
		if (comp) { //c'est une variable compresse
				*(data+longueur+2)=0;
				strcpy(data+longueur+3,"KOMP");
				*(data+longueur+8)=OTH_TAG;
		}
		memcpy(data+2, data2, longueur);
		free(data2);
		if (arch)
				EM_moveSymToExtMem(SYMSTR(nom_var),HS_NULL);
				
		return SymPtr;
}


//=======================================================================================================================
//=========================================== Cre l'arbre  partir des stats ===========================================
//=======================================================================================================================

struct hArbre * mk_arbre(struct hArbre *arbre, unsigned char *stat) {
		short i, j = 0, place, rang = 256 ;
		unsigned short val, min1, min2 ;
		unsigned char *n, *limite ;

		memset(arbre, 0, 512*sizeof(struct hArbre)) ;
		for (i = 0 ; i < 256 ; i++)
				arbre[i].valeur = i ;

		if (*stat != 0) {  //quel est le mode... 1 ou 2
				for (i = 0 ; i < 256 ; i++)
						arbre[i].priorite = stat[(*stat)*i+1]+(*stat == 2 ? 256*stat[(*stat)*i+2] : 0 ) ;  //no caract=(*stat)*i   //copie du nb de caract (les deux octets !!)
		} else {  //mode "mix"
				limite = stat+3+3*stat[1] ;  //nombre de caract nombreux
				for (n = stat+3 ; n < limite ; n += 3)  //copie des nombreux
						arbre[*n].priorite = 256*(*(n+1))+(*(n+2)) ;
				for (n = limite ; n < limite+2*stat[2] ; n += 2)  //copie des peu nombreux
						arbre[*n].priorite = *(n+1) ;
		}
//i=256 !!
		do { //tri selon Huffman
				min1 = min2 = 65500 ;
				for (place = 0 ; place < rang ; place++) {  //recherche des deux plus petits
						val = arbre[place].priorite ;
						if (val != 0 && val < min2) {
								if (val < min1) {
										min2 = min1 ;
										min1 = val ;
										j = i ;
										i = place ;
								} else {
										min2 = val ;
										j = place ;
								}
						}
				}
				if (min2 == 65500)  //on a fini
						break ;
				arbre[rang].gauche = &arbre[i] ;
				arbre[rang].droite = &arbre[j] ;
				arbre[rang].priorite = min1+min2 ;  //on construit l'arbre
				rang++ ;
				arbre[i].priorite = 0 ; //on "efface" ceux qu'on a dj pris en compte
				arbre[j].priorite = 0 ;
		} while (1) ;
	
		return &arbre[i] ;
}

//=======================================================================================================================
//============================================ Affichage d'une page de texte ============================================
//=======================================================================================================================

void arbre_to_tab(struct hArbre *arbre, short val, short nbre, long *tampon) { //enregistrement de l'arbre
		struct hArbre *gauche = arbre->gauche ;
		struct hArbre *droite = arbre->droite ;
//nbre="tage" dans l'arbre
//val=code du caractre 
		if (gauche == NULL && droite == NULL) {  //on est arriv  une feuille
				tampon[arbre->valeur] = ((long)nbre<<16)+val ;
				return ;
		}
		if (gauche != NULL)
				arbre_to_tab(gauche, val, nbre+1, tampon) ;
		if (droite != NULL)
				arbre_to_tab(droite, val+(1<<nbre), nbre+1, tampon) ;
}

//=======================================================================================================================
//================================= Compresse des donnes dans une variable temporaire ==================================
//=======================================================================================================================

unsigned char * comp(unsigned char * data, unsigned short * longueur) {
		struct hArbre *        arbre;
		unsigned char * tampon;
		unsigned char * n2;
		unsigned char * n;
		unsigned char * limite    = data+*longueur-1;
		unsigned char * limite2;
		short           chemin[512];
		short           nbre1       = 0;
		short           nbre2       = 0;
		short           mode;
		unsigned short  val;
		unsigned long   bit         = 0 ;
		short           i;
		HANDLE h;

		if ((arbre = HeapDeref(h=HeapAlloc(512*sizeof(struct hArbre))))==NULL) {
				*longueur=3;
				return NULL;
		}
		if ((tampon = malloc(*longueur+200)) == NULL) {
				HeapFree(h);
				*longueur=3;  //retourne "pas assez de mem"
				return NULL;
		}

		*(unsigned short*)tampon = *(unsigned short*)data ;  //copie des deux premiers octets
		tampon[2] = *limite ;  //copie de la valeur de fin
		
		memset(chemin, 0, 1024) ;
		for (n = data+2 ; n < limite ; n++)
				chemin[*n]++ ;  //cration du tableau de compte des caractres
		for (i = 0 ; i < 256 ; i++) {
				val = chemin[i] ;
				nbre1 += (val && val < 256) ;  //nb de (caract dont le nb est <256 et non nul)
				nbre2 += (val >= 256) ;  //nb de (caract dont le nb est >=256)
		}
		mode = ( ( nbre2 != 0) ? 2 : 1 );  //mode=2 => y'en a  + de 256   -   mode=1 => tout - de 256
		if (nbre1+2*nbre2 < 255*mode)  //taille...
				mode = 0 ;  //mode "mix"

		tampon[3] = mode ;  //copie du mode d'arbre...
		n2 = tampon+4 ;
		if (mode!=0) { //mode 1 ou 2
				for (i = 0 ; i < 256 ; i++) {
						val = chemin[i] ;
						*n2++ = val ;  //stockage du premier octet du nb de carct
						if (mode == 2) //si plein de nb de plus de 256
								*n2++ = val>>8 ;  //stockage du deuxime octet du nb de carct
				}
		} else {  //mode "mix"
				*n2++ = nbre2 ;  //on copie le nb de caract >256
				*n2++ = nbre1 ;  //on copie le nb de caract <256
				for (i = 0 ; i < 256 ; i++) {  //copie des grand nb
						if ((val = chemin[i]) > 255) {  //c'est un gd nb
								*n2++ = i ;  //code du caract
								*n2++ = chemin[i]>>8 ;  //copie de son nb
								*n2++ = val ;           //suite de la copie
						}
				}
				for (i = 0 ; i < 256 ; i++) {  //copie des peu nbreux
						val = chemin[i] ;
						if (val && val < 256) {
								*n2++ = i ;  //code
								*n2++ = val ;  //copie
						}
				}
		}

		arbre_to_tab(mk_arbre(arbre, tampon+3), 0, 0, (long*)chemin) ;  //cration de l'arbre dans chemin
		
		i = 0 ;  //dcalage de bit
		limite2 = tampon+*longueur-10 ;
		for (n = data+2 ; n < limite ; n++) {  //compression
				bit += (unsigned long)(chemin[2*(*n)+1])<<i ;  //copie du code du caractre
				i += chemin[2*(*n)] ;  //longuer du code du caractre
				while (i >= 8) {
						if (n2 >= limite2) {
								HeapFree(h);
								free(tampon);
								*longueur=2;
								return NULL; //incompressible
						}
						*n2++ = bit ;  //enregistrement de 8 bits
						bit >>= 8 ;  
						i -= 8 ;
				}
		}
		if (i > 0)
				*n2++ = bit ;  //enregistrements des derniers bits
		*longueur = n2-tampon ;
						
//Fini:
		HeapFree(h) ;
		return tampon;
}

//=======================================================================================================================
//================================ Dcompresse des donnes dans une variable temporaire =================================
//=======================================================================================================================

unsigned char * decomp(unsigned char * data, unsigned short *longueur) {
		struct hArbre *        arbre;
		struct hArbre *        debut;
		struct hArbre *        lecture;
		unsigned char * tampon;
		unsigned char * n2;
		unsigned char * n;
		short           nbre1 = 0 ;
		unsigned short  val;
		unsigned char   j;
		HANDLE          h;

		if ((arbre = HeapDeref(h=HeapAlloc(512*sizeof(struct hArbre))))==NULL) {
				*longueur=3;
				return NULL;
		}
		*longueur = *(unsigned short*)(data+2) ;

		if ((tampon = malloc(*longueur)) == NULL) {
				HeapFree(h);
				*longueur=3;
				return NULL;  //pb de mem
		}
		debut = mk_arbre(arbre, data+5) ;  //cration de l'arbre avec les stats enregistres
		n = data+6+256*(data[5] == 1)+512*(data[5] == 2)+(3*data[6]+2*data[7]+2)*(data[5] == 0) ;  //recherche du dbut des donne en fonction du mode de stockage de l'arbre
		n2 = tampon ; j = 0 ;
		while (n2-tampon < *longueur-1) {  
				lecture = debut ;
				do {  //recherche du caractre  partir du code
						if (j == 0) {
								nbre1 = *n++ ;
								j += 8 ;
						}
						val = nbre1%2 ;  //lit le bit le plus  droite
						nbre1 >>= 1 ;  //on a lut: on dcale
						j-- ;
						if (val == 0)
								lecture = lecture->gauche ;
						else
								lecture = lecture->droite ;
				} while (lecture->gauche != NULL || lecture->droite != NULL) ;  //on a trouv un caractre ?
				*n2++ = lecture->valeur ; //criture du caractre
		}
		*n2 = data[4] ;
//				nam = mk_ptr(str, longueur+2) ;

//Fini:
		HeapFree(h) ;
		return tampon;
}
